// Profile.cpp: implementation of the CProfile class
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "xkeymacs.h"
#include "Profile.h"
#include "MainFrm.h"
#include <Imm.h>
#include <winperf.h>   // for Windows NT
#include <Shlwapi.h>	// Windows NT/2000: Requires Windows 2000 (or Windows NT 4.0 with Internet Explorer 4.0 or later). 
						// Windows 95/98/Me: Requires Windows 98 (or Windows 95 with Internet Explorer 4.0 or later). 

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#pragma data_seg(".xkmcs")
	CXkeymacsData CProfile::m_XkeymacsData[MAX_APP];
	TASK_LIST CProfile::m_TaskList[MAX_TASKS];
	DWORD CProfile::m_dwTasks;
#pragma data_seg()


enum {INITIAL_SIZE	= 51200};
enum {EXTEND_SIZE	= 25600};

static void Item2AppName(CString *sz)
{
	CString szDefaultTitle;
	szDefaultTitle.LoadString(IDS_DEFAULT_TITLE);
	if (*sz == szDefaultTitle) {
		sz->LoadString(IDS_DEFAULT);
	}

	int nStart, nEnd, nCount;

	nStart	= sz->ReverseFind('(') + 1;
	nEnd	= sz->Find(')', nStart) - 1;
	nCount	= (nEnd + 1) - nStart;
	*sz		= sz->Mid(nStart, nCount);
}

static int IsNotSameString(CComboBox *pApplication, CString szListItem)
{
	CString szItem, szList;
	szList = szListItem;
	Item2AppName(&szList);

	for (int i = 0; i < pApplication->GetCount(); i++) {
		pApplication->GetLBText(i, szItem);
		Item2AppName(&szItem);
		if (!stricmp(szItem, szList)) {
			return 0;
		}
	}

	return 1;
}

static int CountSeparator(CString szMainString, CString szSeparator)
{
	int index	= 0;
	int counter	= 0;

	while ((index = szMainString.Find(szSeparator, index)) != -1) {
		index++;
		counter++;
	}

	return counter;
}

static void GetNthString(CString *szAppName, CString szWindowName,
						 CString szSeparator, int n)
{
	int index = -1;

	while (--n) {
		index = szWindowName.Find(szSeparator, index + 1);
	}

	int nStart;
	if (index != -1) {
		nStart = index + szSeparator.GetLength();
	} else {
		nStart = 0;
	}

	int nEnd = szWindowName.Find(szSeparator, nStart);
	if (nEnd == -1) {
		nEnd = szWindowName.GetLength();
	}

	*szAppName = szWindowName.Mid(nStart, nEnd - nStart);
}

static void GetAppName(CString *szAppName, char *pWindowName)
{
	CString szWindowName(pWindowName);
	CString szSeparator;
	szSeparator.LoadString(IDS_SEPARATE_WINDOWTITLE);
	int nWord = CountSeparator(szWindowName, szSeparator) + 1;

	while (nWord) {
		GetNthString(szAppName, szWindowName, szSeparator, nWord);
		if (szAppName->GetAt(0) == '['		||
			szAppName->Find('.', 0) != -1	||	// for Microsoft Project
			szAppName->Find(']', 0) != -1) {	// for the file name like [foo - bar]
			nWord--;
		} else {
			return;
		}
	}

	*szAppName = szWindowName;
}

BOOL CALLBACK EnumWndProc(HWND hWnd, LPARAM lParam)
{
	CComboBox		*pApplication	= (CComboBox*)lParam;
	PTASK_LIST		pTask			= CProfile::m_TaskList;
	
	char szWindowName[WINDOW_NAME_LENGTH];
	char szClassName[CLASS_NAME_LENGTH];
	WINDOWPLACEMENT wpl;
	
	wpl.length = sizeof(WINDOWPLACEMENT);
	GetWindowText(hWnd, szWindowName, sizeof(szWindowName));
	GetClassName(hWnd, szClassName, sizeof(szClassName));

	CString szAppName;
	// Get Process Name
	DWORD dwProcessId = 0;
	GetWindowThreadProcessId(hWnd, &dwProcessId);
	for (DWORD i = 0; i < CProfile::m_dwTasks; i++) {
		if (pTask[i].dwProcessId == dwProcessId) {
			CString szB2;
			szB2.LoadString(IDS_B2);
			CString szExplorer;
			szExplorer.LoadString(IDS_EXPLORER);
			CString szProject;
			szProject.LoadString(IDS_PROJECT);
			CString szExcel;
			szExcel.LoadString(IDS_EXCEL);
			CString szMSDN;
			szMSDN.LoadString(IDS_MSDN);
			CString szMsimn;
			szMsimn.LoadString(IDS_MSIMN);
			
			// Get Application Name
			if (szWindowName[0] == '\0') {
				continue;
			}
			if (strnicmp(pTask[i].ProcessName, szB2, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szExplorer, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szProject, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szExcel, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szMSDN, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szMsimn, sizeof(pTask[i].ProcessName))) {
				GetAppName(&szAppName, szWindowName);
			} else if (!strnicmp(pTask[i].ProcessName, szB2, sizeof(pTask[i].ProcessName))) {
				szAppName.LoadString(IDS_BECKY);
			} else if (!strnicmp(pTask[i].ProcessName, szExplorer, sizeof(pTask[i].ProcessName))) {
				szAppName.LoadString(IDS_PROGRAM_MANAGER);
			} else if (!strnicmp(pTask[i].ProcessName, szMsimn, sizeof(pTask[i].ProcessName))) {
				szAppName.LoadString(IDS_OUTLOOK_EXPRESS);
			} else if (!strnicmp(pTask[i].ProcessName, szProject, sizeof(pTask[i].ProcessName)) ||
					   !strnicmp(pTask[i].ProcessName, szExcel, sizeof(pTask[i].ProcessName))) {
				CString szSeparator;
				szSeparator.LoadString(IDS_SEPARATE_WINDOWTITLE);
				GetNthString(&szAppName, szWindowName, szSeparator, 1);
			} else if (!strnicmp(pTask[i].ProcessName, szMSDN, sizeof(pTask[i].ProcessName))) {
				szAppName = szWindowName;
			} else {
				szAppName.LoadString(IDS_UNKNOWN_APPLICATION);
			}
			break;
		}
	}
	
	
	if ((IsWindowVisible(hWnd)) &&								// Is visible?
		(GetWindow(hWnd, GW_OWNER) == NULL) &&					// Is top level window?
		(lstrlen(szWindowName) > 0) &&							// Have caption?
		(pApplication->FindString(-1, szClassName) == CB_ERR)) {// Is not same string?
		CString szListItem;
//		szListItem.Format(IDS_APPLICATION_LIST_ITEM, szClassName, szWindowName);		
		szListItem.Format(IDS_APPLICATION_LIST_ITEM, szAppName, pTask[i].ProcessName);
		if (IsNotSameString(pApplication, szListItem)) {
			pApplication->AddString(szListItem);
		}
	}
	return TRUE;
}

	
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CProfile::CProfile()
{

}

CProfile::~CProfile()
{

}

// This method initializes data in the registry, or retrieves and validates registry data.
// bSaveAndValidate specifies a flag that indicates 
// whether registry data is being initialized (FALSE) or data is being retrieved (TRUE). 
void CProfile::UpdateRegistryData(BOOL bSaveAndValidate)
{
	CString		szEntry;
	CString		szApplicationName;
	CString		szApplicationTitle;

	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		// application name
		CString szSection;
		szSection.LoadString(IDS_REG_SECTION_APPLICATION);
		szEntry.Format(IDS_REG_ENTRY_APPLICATION, nApplicationID);
		if (bSaveAndValidate) {	// retrieve
			m_XkeymacsData[nApplicationID].ClearAll();
			szApplicationName = AfxGetApp()->GetProfileString(szSection, szEntry);
			if (szApplicationName.IsEmpty()) {
				if (nApplicationID) {
					continue;
				} else {
					szApplicationName.LoadString(IDS_DEFAULT);
				}
			}
			m_XkeymacsData[nApplicationID].SetApplicationName(szApplicationName);
		} else {				// initialize
			szApplicationName = m_XkeymacsData[nApplicationID].GetApplicationName();
			if (szApplicationName.IsEmpty()) {
				continue;
			}
			AfxGetApp()->WriteProfileString(szSection, szEntry, szApplicationName);
		}

		// application title
		szEntry.LoadString(IDS_REG_ENTRY_APPLICATOIN_TITLE);
		if (bSaveAndValidate) {	// retrieve
			szApplicationTitle = AfxGetApp()->GetProfileString(szApplicationName, szEntry);
			m_XkeymacsData[nApplicationID].SetApplicationTitle(szApplicationTitle);
		} else {				// initialize
			szApplicationTitle = m_XkeymacsData[nApplicationID].GetApplicationTitle();
			AfxGetApp()->WriteProfileString(szApplicationName, szEntry, szApplicationTitle);
		}

		// on/off
		if (bSaveAndValidate) {	// retrieve
			for (int nCommandID = 1; ; nCommandID++) {
				szEntry = CXkeymacsData::GetCommandName(nCommandID);
				if (szEntry.IsEmpty()) {
					break;
				}

				HKEY hKey = 0;
				CString szSubKey;
				szSubKey.LoadString(IDS_REGSUBKEY_DATA);
				szSubKey += "\\" + szApplicationName + "\\" + szEntry;
				if (RegOpenKeyEx(HKEY_CURRENT_USER, szSubKey, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
					// Use registry data
					char szKeyBind[128] = {'\0'};
					DWORD dwKeyBind = sizeof(szKeyBind);
					FILETIME ft = {'\0'};	// not use
					for (DWORD dwIndex = 0;
						 RegEnumKeyEx(hKey, dwIndex, szKeyBind, &dwKeyBind, NULL, NULL, NULL, &ft) == ERROR_SUCCESS;
						 dwIndex++) {
						int nCommandType = 0;
						int nKey = 0;
						ReadKeyBind(&nCommandType, &nKey, szKeyBind);
						m_XkeymacsData[nApplicationID].SetCommandID(nCommandType, nKey, nCommandID);

						memset(szKeyBind, 0, sizeof(szKeyBind));
						dwKeyBind = sizeof(szKeyBind);
					}
					RegCloseKey(hKey);
				} else {
					// Use default setting
					for (int i = 0; ; i++) {
						if (CXkeymacsData::GetDefaultControlID(nCommandID, i) == IDC_CO2) {
							continue;
						}

						int nCommandType = CXkeymacsData::GetDefaultCommandType(nCommandID, i);
						int nKey = CXkeymacsData::GetDefaultCommandKey(nCommandID, i);
						if (nKey == 0) {
							break;
						}
						m_XkeymacsData[nApplicationID].SetCommandID(nCommandType, nKey, nCommandID);
					}
				}
			}
		} else {				// initialize
			// create all commands
			for (int nCommandID = 1; ; nCommandID++) {
				szEntry = CXkeymacsData::GetCommandName(nCommandID);
				if (szEntry.IsEmpty()) {
					break;
				}

				HKEY hKey = 0;
				CString szSubKey;
				szSubKey.LoadString(IDS_REGSUBKEY_DATA);
				szSubKey += "\\" + szApplicationName + "\\" + szEntry;

				RegCreateKeyEx(HKEY_CURRENT_USER, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE,
							   KEY_ALL_ACCESS, NULL, &hKey, NULL);
				RegCloseKey(hKey);
			}
			for (int nCommandType = 0; nCommandType < MAX_COMMAND_TYPE; nCommandType++) {
				for (int nKey = 0; nKey < MAX_KEY; nKey++) {
					int nCommandID = m_XkeymacsData[nApplicationID].GetCommandID(nCommandType, nKey);
					if (!nCommandID) {
						continue;
					}
					szEntry = CXkeymacsData::GetCommandName(nCommandID);
					char szKeyBind[128] = {'\0'};
					WriteKeyBind(nCommandType, nKey, szKeyBind, sizeof(szKeyBind));
					HKEY hKey = 0;
					CString szSubKey;
					szSubKey.LoadString(IDS_REGSUBKEY_DATA);
					szSubKey += "\\" + szApplicationName + "\\" + szEntry + "\\" + szKeyBind;
					RegCreateKeyEx(HKEY_CURRENT_USER, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE,
								   KEY_ALL_ACCESS, NULL, &hKey, NULL);
					RegCloseKey(hKey);
				}
			}
		}

		// kill-ring-max
		szEntry.LoadString(IDS_REG_ENTRY_KILL_RING_MAX);
		if (bSaveAndValidate) {	// retrieve
			int nKillRingMax = AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0);
			m_XkeymacsData[nApplicationID].SetKillRingMax(nKillRingMax);
		} else {				// initialize
			int nKillRingMax = m_XkeymacsData[nApplicationID].GetKillRingMax();
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, nKillRingMax);
		}

		// Setting Style
		szEntry.LoadString(IDS_REG_ENTRY_DISABLE_XKEYMACS);
		if (bSaveAndValidate) {	// retrieve
			int nSettingStyle = SETTING_SPECIFIC;
			if (AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0) != 0) {
				nSettingStyle = SETTING_DISABLE;
			}
			m_XkeymacsData[nApplicationID].SetSettingStyle(nSettingStyle);
		} else {				// initialize
			BOOL bDisableXkeymacs = FALSE;
			if (m_XkeymacsData[nApplicationID].GetSettingStyle() == SETTING_DISABLE) {
				bDisableXkeymacs = TRUE;
			}
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, bDisableXkeymacs);
		}

		// Ignore Meta Ctrl+? when it is undefined.
		szEntry.LoadString(IDC_REG_ENTRY_IGNORE_META_CTRL);
		if (bSaveAndValidate) {	// retrieve
			m_XkeymacsData[nApplicationID].SetIgnoreUndefinedMetaCtrl(AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0));
		} else {				// initialize
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedMetaCtrl());
		}

		// Ignore C-x ? when it is undefined.
		szEntry.LoadString(IDC_REG_ENTRY_IGNORE_C_X);
		if (bSaveAndValidate) {	// retrieve
			m_XkeymacsData[nApplicationID].SetIgnoreUndefinedC_x(AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0));
		} else {				// initialize
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedC_x());
		}
	}
}

void CProfile::LoadRegistryData()
{
	UpdateRegistryData(TRUE);
}

void CProfile::SaveRegistryData()
{
	DeleteAllRegistryData();
	UpdateRegistryData(FALSE);

	SetDllData();
	CMainFrame *pMainFrame = (CMainFrame*)AfxGetMainWnd();
	pMainFrame->m_pXkeymacsDll->UpdateData();
}

void CProfile::SetDllData()
{
	CMainFrame *pMainFrame = (CMainFrame*)AfxGetMainWnd();

	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {

		CString szApplicationName = m_XkeymacsData[nApplicationID].GetApplicationName();

		if (szApplicationName.IsEmpty()) {
			pMainFrame->m_pXkeymacsDll->Clear(nApplicationID);
			continue;
		}

		pMainFrame->m_pXkeymacsDll->SetApplicationName(nApplicationID, szApplicationName);
		pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL, 'X', 0);
		pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL+SHIFT, 'X', 0);

		for (int nCommandType = 0; nCommandType < MAX_COMMAND_TYPE; nCommandType++) {
			for (int nKey = 0; nKey < MAX_KEY; nKey++) {
				int nEnable = m_XkeymacsData[nApplicationID].GetCommandID(nCommandType, nKey);
				pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, nCommandType, nKey, nEnable);
				if ((nCommandType & CONTROLX) && nEnable) {
					pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL, 'X', 1);
					pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL+SHIFT, 'X', 1);
				}
			}
		}

		pMainFrame->m_pXkeymacsDll->SetKillRingMax(nApplicationID, m_XkeymacsData[nApplicationID].GetKillRingMax());
		pMainFrame->m_pXkeymacsDll->SetSettingStyle(nApplicationID, m_XkeymacsData[nApplicationID].GetSettingStyle());
		pMainFrame->m_pXkeymacsDll->SetIgnoreUndefinedMetaCtrl(nApplicationID, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedMetaCtrl());
		pMainFrame->m_pXkeymacsDll->SetIgnoreUndefinedC_x(nApplicationID, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedC_x());
	}
}

void CProfile::ReadKeyBind(int *pnCommandType, int *pnKey, char *szKeyBind)
{
	*pnCommandType = KeyBind2CommandType(szKeyBind);
	*pnKey = KeyBind2Key(szKeyBind + strlen(CommandType2String(*pnCommandType)));
}

void CProfile::WriteKeyBind(int nCommandType, int nKey, char *szKeyBind, int nKeyBindLength)
{
	memset(szKeyBind, 0, nKeyBindLength);

	char *pCommandType	= CommandType2String(nCommandType);
	char *pKey			= Key2String(nKey);
	if (!pCommandType || !pKey) {
		return;
	}

	sprintf(szKeyBind, "%s%s", pCommandType, pKey);
}

int CProfile::KeyBind2CommandType(char *szKeyBind)
{
	for (int nCommandType = MAX_COMMAND_TYPE - 1; nCommandType; nCommandType--) {
		if (IsCommandType(nCommandType, szKeyBind)) {
			return nCommandType;
		}
	}
	return NONE;
}

int CProfile::KeyBind2Key(char *szKey)
{
	for (int nKey = 1; nKey < 0xff; nKey++) {
		if (!strcmp(szKey, Key2String(nKey))) {
			return nKey;
		}
	}
	return 0;
}

char * CProfile::CommandType2String(int nCommandType)
{
	return CommandTypes[nCommandType].szCommandTypeName;
}

char * CProfile::Key2String(int nKey)
{
	return KeyNames[nKey].szKeyName;
}

BOOL CProfile::IsCommandType(int nCommandType, char *szKeyBind)
{
	char *szCommandType = CommandType2String(nCommandType);

	if (!strnicmp(szKeyBind, szCommandType, strlen(szCommandType))) {
		return TRUE;
	}

	return FALSE;
}

void CProfile::InitDllData()
{
	LoadRegistryData();
	SetDllData();
}

void CProfile::ClearData(CString szCurrentApplication)
{
	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		if (m_XkeymacsData[nApplicationID].GetApplicationName() == szCurrentApplication) {
			break;
		}
	}
	if (nApplicationID < MAX_APP) {
		m_XkeymacsData[nApplicationID].ClearAll();
	}
}

// return count of saved settings
int CProfile::GetSavedSettingCount()
{
	int nSavedSetting = 0;

	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		CString szApplicationName;
		szApplicationName = m_XkeymacsData[nApplicationID].GetApplicationName();
		if (!szApplicationName.IsEmpty()) {
			nSavedSetting++;
		}
	}

	return nSavedSetting;
}

void CProfile::InitApplicationList(CComboBox *cApplicationList)
{
	cApplicationList->ResetContent();

	m_dwTasks = GetTaskList(m_TaskList, MAX_TASKS);

	EnumWindows(EnumWndProc, (LPARAM)cApplicationList);

	for (int i = 0; i < MAX_APP; i++) {
		CString szDefault;
		szDefault.LoadString(IDS_DEFAULT);
		CString szApplicationName	= m_XkeymacsData[i].GetApplicationName();
		CString szApplicationTitle	= m_XkeymacsData[i].GetApplicationTitle();

		CString szListItem;
		szListItem.Format(IDS_APPLICATION_LIST_ITEM, szApplicationTitle, szApplicationName);
		if (IsNotSameString(cApplicationList, szListItem) &&
			strcmp(szApplicationName, szDefault) &&
			!szApplicationName.IsEmpty()) {
			cApplicationList->AddString(szListItem);
		}
	}

	// Add IME
	HKL hKL = GetKeyboardLayout(0);
	if (ImmIsIME(hKL)) {
		char szDummy;

		UINT nIMEDescription = ImmGetDescription(hKL, &szDummy, 0);
		nIMEDescription += sizeof(char);	// for NULL
		char *szIMEDescription = new char[nIMEDescription];
		ImmGetDescription(hKL, szIMEDescription, nIMEDescription);

		UINT nIMEFileName = ImmGetIMEFileName(hKL, &szDummy, 0);
		nIMEFileName += sizeof(char);
		char *szIMEFileName = new char[nIMEFileName];
		ImmGetIMEFileName(hKL, szIMEFileName, nIMEFileName);

		CString szIMETitle;
		szIMETitle.Format(IDS_APPLICATION_LIST_ITEM, szIMEDescription, szIMEFileName);
		if (IsNotSameString(cApplicationList, szIMETitle) &&
			(nIMEDescription || nIMEFileName)) {
			cApplicationList->AddString(szIMETitle);
		}

		delete[] szIMEDescription;
		delete[] szIMEFileName;
	}

	// Add Default
	CString szDefaultTitle;
	szDefaultTitle.LoadString(IDS_DEFAULT_TITLE);
	cApplicationList->InsertString( 0, szDefaultTitle);
	cApplicationList->SelectString(-1, szDefaultTitle);
}

DWORD CProfile::GetTaskList(PTASK_LIST pTask, DWORD dwNumTasks)
{
	for (int i = 0; i < MAX_TASKS; i++) {
		ZeroMemory(&pTask[i], sizeof(PTASK_LIST));
	}

	OSVERSIONINFO     verInfo = {0};

	verInfo.dwOSVersionInfoSize = sizeof (verInfo);
	GetVersionEx(&verInfo);

	switch (verInfo.dwPlatformId) {
	case VER_PLATFORM_WIN32_NT:
		return GetTaskListNT(pTask, dwNumTasks);
		break;

	case VER_PLATFORM_WIN32_WINDOWS:
		return GetTaskList95(pTask, dwNumTasks);
		break;

	default:
		AfxMessageBox(IDS_ERR_WINDOWS_VERSION);
		return 0;
	}
}

// Add running application's names to the list
// cf. tlist of a sample program written by Microsoft that says
/*++

Routine Description:

    Provides an API for getting a list of tasks running at the time of the
    API call.  This function uses the registry performance data to get the
    task list and is therefore straight WIN32 calls that anyone can call.

Arguments:

    dwNumTasks       - maximum number of tasks that the pTask array can hold

Return Value:

    Number of tasks placed into the pTask array.

--*/
DWORD CProfile::GetTaskListNT(PTASK_LIST pTask, DWORD dwNumTasks)
{
	DWORD	rc;
	DWORD	i;
	HKEY	hKeyNames;
	DWORD	dwType;
	DWORD	dwSize;
	LPBYTE	buf = NULL;
	CHAR	szSubKey[1024];

	//
	// Look for the list of counters.  Always use the neutral
	// English version, regardless of the local language.  We
	// are looking for some particular keys, and we are always
	// going to do our looking in English.  We are not going
	// to show the user the counter names, so there is no need
	// to go find the corresponding name in the local language.
	//
	{
		LANGID	lid = MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL);
		CString szRegsubkeyPere;
		szRegsubkeyPere.LoadString(IDS_REGSUBKEY_PERF);
		sprintf(szSubKey, szRegsubkeyPere, lid);
		rc = RegOpenKeyEx(HKEY_LOCAL_MACHINE, szSubKey, 0, KEY_READ, &hKeyNames);
	}
	if (rc != ERROR_SUCCESS) {
		goto exit;
	}

	//
	// get the buffer size for the counter names
	//
	LoadString(AfxGetInstanceHandle(), IDS_REGSUBKEY_COUNTERS, szSubKey, sizeof(szSubKey));
	rc = RegQueryValueEx(hKeyNames, szSubKey, NULL, &dwType, NULL, &dwSize);

	if (rc != ERROR_SUCCESS) {
		goto exit;
	}

	//
	// allocate the counter names buffer
	//
	buf = (LPBYTE) calloc(dwSize, sizeof(BYTE));
	if (buf == NULL) {
		goto exit;
	}

	//
	// read the counter names from the registry
	//
	LoadString(AfxGetInstanceHandle(), IDS_REGSUBKEY_COUNTERS, szSubKey, sizeof(szSubKey));
	rc = RegQueryValueEx(hKeyNames, szSubKey, NULL, &dwType, buf, &dwSize);

	if (rc != ERROR_SUCCESS) {
		goto exit;
	}

	//
	// now loop thru the counter names looking for the following counters:
	//
	//      1.  "Process"           process name
	//      2.  "ID Process"        process id
	//
	// the buffer contains multiple null terminated strings and then
	// finally null terminated at the end.  the strings are in pairs of
	// counter number and counter name.
	//
	LPSTR p;
	LPSTR p2;
	DWORD dwProcessIdTitle;
	p = (LPSTR)buf;
	while (*p) {
		if (p > (LPSTR)buf) {
			for (p2 = p - 2; isdigit(*p2); p2--) {
				;
			}
		}

		CString szProcess;
		szProcess.LoadString(IDS_PROCESS);
		CString szProcessId;
		szProcessId.LoadString(IDS_PROCESSID);

		if (stricmp(p, szProcess) == 0) {
			//
			// look backwards for the counter number
			//
			for (p2 = p - 2; isdigit(*p2); p2--) {
				;
			}
			strcpy( szSubKey, p2 + 1 );
		} else if (stricmp(p, szProcessId) == 0) {
			//
			// look backwards for the counter number
			//
			for (p2 = p - 2; isdigit(*p2); p2--) {
				;
			}
			dwProcessIdTitle = atol(p2 + 1);
		}
		//
		// next string
		//
		p += (strlen(p) + 1);
	}

	//
	// free the counter names buffer
	//
	free(buf);


	//
	// allocate the initial buffer for the performance data
	//
	dwSize = INITIAL_SIZE;
	buf = (LPBYTE) calloc(dwSize, sizeof(BYTE));
	if (buf == NULL) {
		goto exit;
	}

	PPERF_DATA_BLOCK pPerf;
	while (TRUE) {

		rc = RegQueryValueEx( HKEY_PERFORMANCE_DATA, szSubKey, NULL, &dwType, buf, &dwSize);

		pPerf = (PPERF_DATA_BLOCK) buf;

		//
		// check for success and valid perf data block signature
		//
		if ((rc == ERROR_SUCCESS)				&&
			(dwSize > 0)						&&
			(pPerf)->Signature[0] == (WCHAR)'P' &&
			(pPerf)->Signature[1] == (WCHAR)'E' &&
			(pPerf)->Signature[2] == (WCHAR)'R' &&
			(pPerf)->Signature[3] == (WCHAR)'F' ) {
			break;
		}

		//
		// if buffer is not big enough, reallocate and try again
		//
		if (rc == ERROR_MORE_DATA) {
			dwSize += EXTEND_SIZE;
			buf = (LPBYTE) realloc( buf, dwSize );
			memset( buf, 0, dwSize );
		} else {
			goto exit;
		}
	}

	//
	// set the perf_object_type pointer
	//
	PPERF_OBJECT_TYPE pObj;
	pObj = (PPERF_OBJECT_TYPE) ((DWORD)pPerf + pPerf->HeaderLength);

	//
	// loop thru the performance counter definition records looking
	// for the process id counter and then save its offset
	//
	DWORD dwProcessIdCounter;
	PPERF_COUNTER_DEFINITION pCounterDef;
	pCounterDef = (PPERF_COUNTER_DEFINITION) ((DWORD)pObj + pObj->HeaderLength);
	for (i = 0; i < pObj->NumCounters; i++) {
		if (pCounterDef->CounterNameTitleIndex == dwProcessIdTitle) {
			dwProcessIdCounter = pCounterDef->CounterOffset;
			break;
		}
		pCounterDef++;
	}

	DWORD dwLimit;
	dwLimit = dwNumTasks - 1;
	dwNumTasks = min( dwLimit, (DWORD)pObj->NumInstances );

	PPERF_INSTANCE_DEFINITION pInst;
	pInst = (PPERF_INSTANCE_DEFINITION) ((DWORD)pObj + pObj->DefinitionLength);

	//
	// loop thru the performance instance data extracting each process name
	// and process id
	//
	for (i = 0; i < dwNumTasks; i++) {
		//
		// pointer to the process name
		//
		p = (LPSTR) ((DWORD)pInst + pInst->NameOffset);

		//
		// convert it to ascii
		//
		CHAR szProcessName[MAX_PATH];
		rc = WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)p, -1, szProcessName,
								 sizeof(szProcessName), NULL, NULL);

		if (!rc) {
			//
			// if we cant convert the string then use a default value
			//
			CString szUnknownTask;
			szUnknownTask.LoadString(IDS_UNKNOWN_TASK);
			strcpy(pTask->ProcessName, szUnknownTask);
		}

		if (strlen(szProcessName)+4 <= sizeof(pTask->ProcessName)) {
			CString szExe;
			szExe.LoadString(IDS_EXTENSION_EXECUTABLE);

			strcpy(pTask->ProcessName, szProcessName);
			strcat(pTask->ProcessName, szExe);
		}

		//
		// get the process id
		//
		PPERF_COUNTER_BLOCK pCounter = (PPERF_COUNTER_BLOCK) ((DWORD)pInst + pInst->ByteLength);
//		pTask->flags = 0;
		pTask->dwProcessId = *((LPDWORD) ((DWORD)pCounter + dwProcessIdCounter));
		if (pTask->dwProcessId == 0) {
			pTask->dwProcessId = (DWORD) - 2;
		}

		//
		// next process
		//
		pTask++;
		pInst = (PPERF_INSTANCE_DEFINITION) ((DWORD)pCounter + pCounter->ByteLength);
	}

exit:
	if (buf) {
		free(buf);
	}

	RegCloseKey( hKeyNames );
	RegCloseKey( HKEY_PERFORMANCE_DATA );

	return dwNumTasks;
//	return;
}

/*++

Routine Description:

    Provides an API for getting a list of tasks running at the time of the
    API call.  This function uses Toolhelp32to get the task list and is 
    therefore straight WIN32 calls that anyone can call.

Arguments:

    dwNumTasks       - maximum number of tasks that the pTask array can hold

Return Value:

    Number of tasks placed into the pTask array.

--*/
DWORD CProfile::GetTaskList95(PTASK_LIST pTask, DWORD dwNumTasks)
{
	CREATESNAPSHOT pCreateToolhelp32Snapshot = NULL;
	PROCESSWALK    pProcess32First           = NULL;
	PROCESSWALK    pProcess32Next            = NULL;

	HMODULE        hKernel        = NULL;
	HANDLE         hProcessSnap   = NULL;
	PROCESSENTRY32 pe32           = {0};
	DWORD          dwTaskCount    = 0;


	// Guarantee to the code later on that we'll enum at least one task.
	if (dwNumTasks == 0) {
		return 0;
	}

	// Obtain a module handle to KERNEL so that we can get the addresses of
	// the 32-bit Toolhelp functions we need.
	hKernel = GetModuleHandle("KERNEL32.DLL");

	if (hKernel) {
		pCreateToolhelp32Snapshot =
			(CREATESNAPSHOT)GetProcAddress(hKernel, "CreateToolhelp32Snapshot");

		pProcess32First = (PROCESSWALK)GetProcAddress(hKernel, "Process32First");
		pProcess32Next  = (PROCESSWALK)GetProcAddress(hKernel, "Process32Next");
	}

	// make sure we got addresses of all needed Toolhelp functions.
	if (!(pProcess32First && pProcess32Next && pCreateToolhelp32Snapshot)) {
		return 0;
	}

	// Take a snapshot of all processes currently in the system.
	hProcessSnap = pCreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (hProcessSnap == (HANDLE)-1) {
		return 0;
	}

	// Walk the snapshot of processes and for each process, get information
	// to display.
	dwTaskCount = 0;
	pe32.dwSize = sizeof(PROCESSENTRY32);   // must be filled out before use
	if (pProcess32First(hProcessSnap, &pe32)) {
		do {
			LPSTR pCurChar;

			// strip path and leave executabe filename splitpath
			for (pCurChar = (pe32.szExeFile + lstrlen (pe32.szExeFile));
				*pCurChar != '\\' && pCurChar != pe32.szExeFile; 
				--pCurChar)

			lstrcpy(pTask -> ProcessName, pCurChar);
//			pTask -> flags = 0;
			pTask -> dwProcessId = pe32.th32ProcessID;

			++dwTaskCount;   // keep track of how many tasks we've got so far
			++pTask;         // get to next task info block.
		} while (dwTaskCount < dwNumTasks && pProcess32Next(hProcessSnap, &pe32));
	} else {
		dwTaskCount = 0;    // Couldn't walk the list of processes.
	}

	// Don't forget to clean up the snapshot object...
	CloseHandle (hProcessSnap);

	return dwTaskCount;
}

// return application index
// and update setting style
// if there is NOT the application in the data, this function takes care of it.
int CProfile::GetApplicationIndex(CString szApplicationName, BOOL bSaveAndValidate, int *nSettingStyle)
{
	if (!bSaveAndValidate) {	// SetDialogData
		*nSettingStyle = SETTING_UNDEFINED;
	}

	int nApplicationID = GetApplicationIndex(szApplicationName);

	if (nApplicationID == MAX_APP) {
		if (bSaveAndValidate) {	// GetDialogData
			for (nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
				CString sz = m_XkeymacsData[nApplicationID].GetApplicationName();
				if (sz.IsEmpty()) {
					m_XkeymacsData[nApplicationID].SetApplicationName(szApplicationName);
					break;
				}
			}
			if (nApplicationID == MAX_APP) {
				return nApplicationID;
			}
		} else {				// SetDialogData
			for (nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
				if (IsDefault(m_XkeymacsData[nApplicationID].GetApplicationName())) {
					*nSettingStyle = SETTING_DEFAULT;
					break;
				}
			}
			if (nApplicationID == MAX_APP) {
				return nApplicationID;
			}
		}
	}

	if (bSaveAndValidate) {	// GetDialogData
		m_XkeymacsData[nApplicationID].SetSettingStyle(*nSettingStyle);
	} else {				// SetDialogData
		if (*nSettingStyle == SETTING_UNDEFINED) {	// It means that *nSettingStyle != SETTING_DEFAULT.
			*nSettingStyle = m_XkeymacsData[nApplicationID].GetSettingStyle();
		}
	}

	return nApplicationID;
}

// if sz is "Default", return TRUE
BOOL CProfile::IsDefault(CString sz)
{
	CString szDefault;
	szDefault.LoadString(IDS_DEFAULT);

	if (szDefault == sz) {
		return TRUE;
	}

	return FALSE;
}

void CProfile::GetApplicationTitle(CComboBox *cApplicationList, CString &rList, int nIndex)
{
	if (0 <= nIndex) {
		cApplicationList->GetLBText(nIndex, rList);
	} else {
		cApplicationList->GetWindowText(rList);
	}

	CString szDefaultTitle;
	szDefaultTitle.LoadString(IDS_DEFAULT_TITLE);
	if (rList == szDefaultTitle) {
		rList.LoadString(IDS_DEFAULT);
	}
	return;
}

void CProfile::UpdateApplicationTitle(CComboBox *cApplicationList, CString szCurrentApplication, int nApplicationID, BOOL bSaveAndValidate)
{
	static CString szApplicationTitle;
	if (bSaveAndValidate) {	// GetDialogData
		if (!CProfile::IsDefault(szCurrentApplication)) {
			m_XkeymacsData[nApplicationID].SetApplicationTitle(szApplicationTitle);
		}
		szApplicationTitle.Empty();
	} else {				// SetDialogData
		CString szListItem;
		CProfile::GetApplicationTitle(cApplicationList, szListItem);
		int nEndTitle = szListItem.ReverseFind('(');
		if (nEndTitle > 0) {
			szApplicationTitle = szListItem.Left(nEndTitle);
		}
	}
}

void CProfile::SetCommandID(int nApplicationID, int nCommandType, int nKey, int nCommandID)
{
	m_XkeymacsData[nApplicationID].SetCommandID(nCommandType, nKey, nCommandID);
}

int CProfile::GetCommandID(int nApplicationID, int nCommandType, int nKey)
{
	return m_XkeymacsData[nApplicationID].GetCommandID(nCommandType, nKey);
}

void CProfile::SetKillRingMax(int nApplicationID, int nKillRingMax)
{
	m_XkeymacsData[nApplicationID].SetKillRingMax(nKillRingMax);
}

int CProfile::GetKillRingMax(int nApplicationID)
{
	return m_XkeymacsData[nApplicationID].GetKillRingMax();
}

void CProfile::DeleteAllRegistryData()
{
	HKEY hkey;
	CString szSubKey;
	szSubKey.LoadString(IDS_REGSUBKEY_DATA);
	VERIFY(RegOpenKeyEx(HKEY_CURRENT_USER, szSubKey, 0, KEY_ALL_ACCESS, &hkey) == ERROR_SUCCESS);

	// I am sure that I have to do only one time, but...
	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		DWORD dwIndex = 0;
		char szName[SUB_KEY_NAME_LENGTH];
		DWORD dwName = sizeof(szName);
		ZeroMemory(szName, sizeof(szName));
		FILETIME filetime;

		while (RegEnumKeyEx(hkey, dwIndex, szName, &dwName, NULL, NULL, NULL, &filetime) == ERROR_SUCCESS) {
//			VERIFY(RegDeleteKey(hkey, szName) == ERROR_SUCCESS);
			VERIFY(SHDeleteKey(hkey, szName) == ERROR_SUCCESS);
			ZeroMemory(szName, sizeof(szName));
			dwName = sizeof(szName);
		}
	}

	VERIFY(RegCloseKey(hkey) == ERROR_SUCCESS);
}

int CProfile::GetCurrentApplicationID(CComboBox *cApplicationList, CString szCurrentApplication)
{
	int nCounter = cApplicationList->GetCount();
	CString szListItem;
	int nCurSel = cApplicationList->GetCurSel();

	for (int i = 0; i < nCounter; i++) {
		cApplicationList->SetCurSel(i);
		CProfile::GetApplicationTitle(cApplicationList, szListItem);
		if (szListItem.Find(szCurrentApplication) != -1) {
			cApplicationList->SetCurSel(nCurSel);
			return i;
		}
	}
	return -1;
}

void CProfile::CopyData(CString szDestinationApplication, CString szSourceApplication)
{
	int nSettingStyle = SETTING_SPECIFIC;
	int nDestinationApplication = GetApplicationIndex(szDestinationApplication, TRUE, &nSettingStyle);
	int nSourceApplication = GetApplicationIndex(szSourceApplication);

	CString szApplicationName = m_XkeymacsData[nDestinationApplication].GetApplicationName();
	CString szApplicationTitle = m_XkeymacsData[nDestinationApplication].GetApplicationTitle();

	m_XkeymacsData[nDestinationApplication] = m_XkeymacsData[nSourceApplication];

	m_XkeymacsData[nDestinationApplication].SetApplicationName(szApplicationName);
	m_XkeymacsData[nDestinationApplication].SetApplicationTitle(szApplicationTitle);
}

// return application index
// if there is NOT the application in the data, return MAX_APP
int CProfile::GetApplicationIndex(CString szApplicationName)
{
	int nApplicationID = 0;
	for (nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		if (m_XkeymacsData[nApplicationID].GetApplicationName() == szApplicationName) {
			break;
		}
	}
	return nApplicationID;
}
