// Profile.h: interface of the CProfile class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROFILE_H__9415254D_4656_484B_A730_E02580D8A221__INCLUDED_)
#define AFX_PROFILE_H__9415254D_4656_484B_A730_E02580D8A221__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

BOOL CALLBACK EnumWndProc(HWND hWnd, LPARAM lParam);

#define PROCESS_SIZE        MAX_PATH

//
// task list structure
//
typedef struct _TASK_LIST {
    DWORD       dwProcessId;
//    DWORD       dwInheritedFromProcessId;
//    BOOL        flags;
//    HANDLE      hwnd;
    CHAR        ProcessName[PROCESS_SIZE];
//    CHAR        WindowTitle[TITLE_SIZE];
} TASK_LIST, *PTASK_LIST;

enum {MAX_TASKS		=   256};

class CProfile
{
public:
	static int GetApplicationIndex(CString szApplicationName);
	static void CopyData(CString szDestinationApplication, CString szSourceApplication);
	static void ReadKeyBind(int *pnCommandType, int *pnKey, char *szKeyBind);
	static char * Key2String(int nKey);
	static char * CommandType2String(int nCommandType);
	static int GetCurrentApplicationID(CComboBox *cApplicationList, CString szCurrentApplication);
	static int GetKillRingMax(int nApplicationID);
	static void SetKillRingMax(int nApplicationID, int nKillRingMax);
	static int GetCommandID(int nApplicationID, int nCommandType, int nKey);
	static void SetCommandID(int nApplicationID, int nCommandType, int nKey, int nCommandID);
	static void UpdateApplicationTitle(CComboBox *cApplicationList, CString szCurrentApplication, int nApplicationID, BOOL bSaveAndValidate);
	static void GetApplicationTitle(CComboBox *cApplicationList, CString &rList, int nIndex = -1);
	static BOOL IsDefault(CString sz);
	static int GetApplicationIndex(CString szApplicationName, BOOL bSaveAndValidate, int *nSettingStyle);
	static TASK_LIST m_TaskList[MAX_TASKS];
	static DWORD m_dwTasks;
	static void InitApplicationList(CComboBox *cApplicationList);
	static int GetSavedSettingCount();
	static void ClearData(CString szCurrentApplication);
	static void InitDllData();
	static void SaveRegistryData();
	static void LoadRegistryData();
	CProfile();
	virtual ~CProfile();

protected:
	static void SetDllData();
	static CXkeymacsData m_XkeymacsData[MAX_APP];
	static void DeleteAllRegistryData();
	static DWORD GetTaskList95(PTASK_LIST pTask, DWORD dwNumTasks);
	static DWORD GetTaskListNT(PTASK_LIST pTask, DWORD dwNumTasks);
	static DWORD GetTaskList(PTASK_LIST pTask, DWORD dwNumTasks);
	static BOOL IsCommandType(int nCommandType, char *szKeyBind);
	static int KeyBind2Key(char *szKey);
	static int KeyBind2CommandType(char *szKeyBind);
	static void WriteKeyBind(int nCommandType, int nKey, char *szKeyBind, int nKeyBindLength);
	static void UpdateRegistryData(BOOL bSaveAndValidate);
};

#endif // !defined(AFX_PROFILE_H__9415254D_4656_484B_A730_E02580D8A221__INCLUDED_)
