// Commands.cpp: implementation of the CCommands class
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Commands.h"
#include "xkeymacsdll.h"
#include "Utils.h"
#include <math.h>
#include <Imm.h>
#pragma data_seg(".xkmcs")
DWORD CCommands::m_nNumericArgument = 1;
BOOL CCommands::m_bSetMark = FALSE;
BOOL CCommands::m_bC_x = FALSE;
BOOL CCommands::m_bM_ = FALSE;
BOOL CCommands::m_bDefaultNumericArgument = TRUE;
BOOL CCommands::m_bNegativeNumericArgument = FALSE;
BOOL CCommands::m_bC_u = FALSE;
SEARCH_DIRECTION CCommands::m_SearchDirection = NA;
#pragma data_seg()


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCommands::CCommands()
{

}

CCommands::~CCommands()
{

}

void CCommands::DepressKey(BYTE bVk)
{
	CXkeymacsDll::DepressKey(bVk);
}

void CCommands::ReleaseKey(BYTE bVk)
{
	CXkeymacsDll::ReleaseKey(bVk);
}

void CCommands::Kdu(BYTE bVk1, BYTE bVk2, BYTE bVk3)
{
	BOOL bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
	BOOL bIsAltDown = CXkeymacsDll::IsDown(VK_MENU);

	if (bIsCtrlDown) {
		BYTE ks[256];
		GetKeyboardState( ks );
		ks[ VK_CONTROL ] = 0;
		SetKeyboardState( ks );

		ReleaseKey(VK_CONTROL);
	}

	if (bIsAltDown) {
		ReleaseKey(VK_MENU);
	}

	CXkeymacsDll::Kdu(bVk1, m_nNumericArgument);
	if (bVk2) {
		CXkeymacsDll::Kdu(bVk2, m_nNumericArgument);
	}
	if (bVk3) {
		CXkeymacsDll::Kdu(bVk3, m_nNumericArgument);
	}

	if (bIsAltDown) {
		DepressKey(VK_MENU);
	}

	if (bIsCtrlDown) {
		DepressKey(VK_CONTROL);

		BYTE ks[256];
		GetKeyboardState( ks );
		ks[ VK_CONTROL ] = 1;
		SetKeyboardState( ks );
	}
}

void CCommands::SdKduSu(BYTE bVk1, BYTE bVk2)
{
	BOOL bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
	BOOL bIsAltDown = CXkeymacsDll::IsDown(VK_MENU);
	BOOL bIsShiftDown = CXkeymacsDll::IsDown(VK_SHIFT);

	if (bIsCtrlDown) {
		ReleaseKey(VK_CONTROL);
	}
	if (bIsAltDown) {
		ReleaseKey(VK_MENU);
	}
	if (!bIsShiftDown) {
		DepressKey(VK_SHIFT);
	}

	CXkeymacsDll::Kdu(bVk1, m_nNumericArgument);
	if (bVk2) {
		CXkeymacsDll::Kdu(bVk2, m_nNumericArgument);
	}

	if (!bIsShiftDown) {
		ReleaseKey(VK_SHIFT);
	}
	if (bIsAltDown) {
		DepressKey(VK_MENU);
	}
	if (bIsCtrlDown) {
		DepressKey(VK_CONTROL);
	}
}

void CCommands::CdKduCu(BYTE bVk1, BYTE bVk2)
{
	BOOL bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
	BOOL bIsAltDown = CXkeymacsDll::IsDown(VK_MENU);
	BOOL bIsShiftDown = CXkeymacsDll::IsDown(VK_SHIFT);

	if (!bIsCtrlDown) {
		DepressKey(VK_CONTROL);

		BYTE ks[256];
		GetKeyboardState( ks );
		ks[ VK_CONTROL ] = 1;
		SetKeyboardState( ks );
	}
	if (bIsAltDown) {
		ReleaseKey(VK_MENU);
	}
	if (bIsShiftDown && (!m_bSetMark || CXkeymacsDll::Original(CONTROL, bVk1))) {
		ReleaseKey(VK_SHIFT);
	}

	CXkeymacsDll::Kdu(bVk1, m_nNumericArgument);
	if (bVk2) {
		CXkeymacsDll::Kdu(bVk2, m_nNumericArgument);
	}

	if (bIsShiftDown && (!m_bSetMark || CXkeymacsDll::Original(CONTROL, bVk1))) {
		DepressKey(VK_SHIFT);
	}
	if (bIsAltDown) {
		DepressKey(VK_MENU);
	}
	if (!bIsCtrlDown) {
		BYTE ks[256];
		GetKeyboardState( ks );
		ks[ VK_CONTROL ] = 0;
		SetKeyboardState( ks );

		ReleaseKey(VK_CONTROL);
	}
}

void CCommands::AdKduAu(BYTE bVk1, BYTE bVk2, BYTE bVk3)
{
	BOOL bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
	BOOL bIsAltDown = CXkeymacsDll::IsDown(VK_MENU);
	BOOL bIsShiftDown = CXkeymacsDll::IsDown(VK_SHIFT);

	if (bIsCtrlDown) {
		ReleaseKey(VK_CONTROL);
	}

	if (!bIsAltDown) {
		DepressKey(VK_MENU);
	}

	if (bIsShiftDown) {
		ReleaseKey(VK_SHIFT);
	}

	CXkeymacsDll::Kdu(bVk1, m_nNumericArgument);
	if (bVk2) {
		CXkeymacsDll::Kdu(bVk2, m_nNumericArgument);
	}
	if (bVk3) {
		CXkeymacsDll::Kdu(bVk3, m_nNumericArgument);
	}

	if (bIsShiftDown) {
		DepressKey(VK_SHIFT);
	}

	if (!bIsAltDown) {
		ReleaseKey(VK_MENU);
	}

	if (bIsCtrlDown) {
		DepressKey(VK_CONTROL);
	}
}

// C-a: Home
int CCommands::BeginningOfLine()
{
//	if (!m_bDefaultNumericArgument) {
//		DecreaseNumericArgument();
//		NextLine();
//	}
	ClearNumericArgument();
	Kdu(VK_HOME);
	return Reset(GOTO_HOOK);
}

// C-b: Left
int CCommands::BackwardChar()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return ForwardChar();
	}

	Kdu(VK_LEFT);
	return Reset(GOTO_HOOK);
}

// M-b: backward-word
int CCommands::BackwardWord()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return ForwardWord();
	}

	CdKduCu(VK_LEFT);
	return Reset(GOTO_HOOK);
}

// C-e: End
int CCommands::EndOfLine()
{
//	if (!m_bDefaultNumericArgument) {
//		DecreaseNumericArgument();
//		NextLine();
//	}
	ClearNumericArgument();
	Kdu(VK_END);
	return Reset(GOTO_HOOK);
}

// C-f: Right		
int CCommands::ForwardChar()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return BackwardChar();
	}

	Kdu(VK_RIGHT);
	return Reset(GOTO_HOOK);
}

// M-f: forward-word
int CCommands::ForwardWord()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return BackwardWord();
	}

	CdKduCu(VK_RIGHT);
	return Reset(GOTO_HOOK);
}

// C-n: Down
int CCommands::NextLine()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return PreviousLine();
	}

	Kdu(VK_DOWN);
	return Reset(GOTO_HOOK);
}

// C-o: open-line
int CCommands::OpenLine()
{
//	Kdu(VK_RETURN, VK_LEFT);
	int n = m_nNumericArgument;
	ClearNumericArgument();
	while (n--) {
		Kdu(VK_RETURN, VK_UP, VK_END);
	}
	return Reset(GOTO_HOOK);
}

// C-p: Up
int CCommands::PreviousLine()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return NextLine();
	}

	Kdu(VK_UP);
	return Reset(GOTO_HOOK);
}

int CCommands::QueryReplace()
{
	ClearNumericArgument();
	if (CUtils::IsBecky()) {
		CXkeymacsDll::Original(CONTROL, 'Q', TRUE);
		CXkeymacsDll::Original(CONTROL, 'A', TRUE);
		CdKduCu('Q', 'A');
	} else if (CUtils::IsLotusNotes() ||
			   CUtils::IsInternetExplorer()) {
		CXkeymacsDll::Original(CONTROL, 'F', TRUE);
		CdKduCu('F');
	} else {
		CXkeymacsDll::Original(CONTROL, 'H', TRUE);
		CdKduCu('H');
	}
	return Reset(GOTO_HOOK);
}

int CCommands::QueryReplaceRegexp()
{
	return QueryReplace();
}

// M-<:
int CCommands::BeginningOfBuffer()
{
	ClearNumericArgument();
	CdKduCu(VK_HOME);
	return Reset(GOTO_HOOK);
}

// M->:
int CCommands::EndOfBuffer()
{
	ClearNumericArgument();
	CdKduCu(VK_END);
	return Reset(GOTO_HOOK);
}

// C-h: Back space
int CCommands::DeleteBackwardChar()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return DeleteChar();
	}

	Kdu(VK_BACK);
	return Reset(GOTO_HOOK);
}

// C-d: Delete
int CCommands::DeleteChar()
{
	if (m_bNegativeNumericArgument) {
		m_bNegativeNumericArgument = FALSE;
		return DeleteBackwardChar();
	}

	Kdu(VK_DELETE);
	return Reset(GOTO_HOOK);
}

// C-k: Shift-End, Shift-Delete, if the cursor is not at EOL (is End Of Line)
//		Shift-Right, Cut, if the cursor is at EOL
int CCommands::KillLine()
{
	ClearNumericArgument();	// tmp

	if (CUtils::IsLotus123()) {
		// C-k: Shift-End, Control-x
//		CancelSelection();
		SdKduSu(VK_END);
		CdKduCu('W');
		return Reset(GOTO_HOOK);
	}

	{
		static CString szOriginalClipboardText;
		// Do not try to do these command at once.
		// Clipboard has old data till you go out this function.
		static int nStep = 0;
		static CString szClipboardText;
		static BOOL bContinuous = FALSE;

		switch (nStep) {
		case 0:
//			CancelSelection();
			{
//				CString sz;
//				sz.Format("wLastParam == %c (%d)", wLastParam, wLastParam);
//				AfxMessageBox(sz);
			}

///			if (wLastParam == 'K') {
///				bContinuous = TRUE;
///			} else {
///				bContinuous = FALSE;
//				CancelSelection();
///			}
			if (CUtils::IsMicrosoftWord()) {
				// wLastParam always 'K' on M$ Word.
				// I can NOT understand why does Xkeymacs behave like this.
				bContinuous = FALSE;
			}

			szOriginalClipboardText.Empty();
			if (!CUtils::GetClipboardText(&szOriginalClipboardText)) {
				szOriginalClipboardText.Empty();
			}

			if (!CopyNextCharacter()) {
//				AfxMessageBox("Error: CopyNextCharacter");
				return Reset(GOTO_DO_NOTHING);
			}
			nStep = 1;
			return Reset(GOTO_RECURSIVE);
		case 1:
			nStep = 0;

			szClipboardText.Empty();
			CUtils::GetClipboardText(&szClipboardText);

//			{
//				CString sz;
//				sz.Format("%x, %s", szClipboardText.GetAt(0), szClipboardText);
//				AfxMessageBox(sz);
//			}

			if (szClipboardText.IsEmpty()) {	// EOF
//				AfxMessageBox("EOF");
				if (CUtils::IsMicrosoftWord() ||
					CUtils::IsMicrosoftFrontPage() ||
					CUtils::IsLotusWordPro()    ) {
					Kdu(VK_END);
					SdKduSu(VK_RIGHT);
					CdKduCu('W');
					nStep = 2;
					return Reset(GOTO_RECURSIVE);
				} else if (CUtils::IsLotusNotes()) {
					Kdu(VK_END);
					SdKduSu(VK_DOWN);
					SdKduSu(VK_HOME);
					CdKduCu('W');
					nStep = 2;
					return Reset(GOTO_RECURSIVE);
				} else {
					// default
					Kdu(VK_RIGHT);
					if (!CUtils::SetClipboardText(&szOriginalClipboardText)) {
						//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
					}
					return Reset(GOTO_HOOK);
				}
			}

			if (szClipboardText.GetAt(0) != VK_RETURN) {
				if (CUtils::IsMicrosoftWord()) {
					SdKduSu(VK_END, VK_LEFT);
					SdKduSu(VK_DELETE);
				} else {
					SdKduSu(VK_END, VK_DELETE);

//					if (CUtils::IsMicrosoftWord() ||
//						CUtils::IsLotusWordPro()    ) {
					if (CUtils::IsLotusWordPro()    ) {
						Kdu(VK_RETURN);
						Kdu(VK_LEFT);
					}
				}

//				SdKduSu(VK_END);
//				if (CUtils::IsMicrosoftWord() ||
//					CUtils::IsLotusWordPro()    ) {
//					SdKduSu(VK_LEFT);
//				}
//				CdKduCu('W');
			} else {
				SdKduSu(VK_RIGHT);
				CdKduCu('W');
			}

			nStep = 2;
			return Reset(GOTO_RECURSIVE);
		case 2:
			{
				nStep = 0;
				szClipboardText.Empty();
				CUtils::GetClipboardText(&szClipboardText);

//				CString sz;
//				sz.Format("%x, %x, %x, %x, %x, %x, %s", szClipboardText.GetAt(0), szClipboardText.GetAt(1), szClipboardText.GetAt(2), szClipboardText.GetAt(3), szClipboardText.GetAt(4), szClipboardText.GetAt(5), szClipboardText);
//				AfxMessageBox(sz);

				int nEnter = szClipboardText.Find(VK_RETURN, 1);
				if ( nEnter != -1 ) {
					Kdu(VK_RETURN);
					Kdu(VK_LEFT);
					szClipboardText = szClipboardText.Left(nEnter);
				}

				nStep = 3;
				return Reset(GOTO_RECURSIVE);
			}
		case 3:
			nStep = 0;
			if (!szClipboardText.IsEmpty()) {
				if (!CUtils::SetClipboardText(&szClipboardText)) {
					//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
				}
			}

			// If you check wLastParam here, wLastParam is always 'K', cos ...
			// So I set bContinuous in Step 0.
			if (bContinuous) {
				CString szClipboardText1;
				CUtils::GetClipboardText(&szClipboardText1);
				szOriginalClipboardText += szClipboardText1;
				CUtils::SetClipboardText(&szOriginalClipboardText);
			}

			nStep = 4;
			return Reset(GOTO_RECURSIVE);
		case 4:
			nStep = 0;
			CXkeymacsDll::AddKillRing();
			return Reset(GOTO_HOOK);
			break;
		}
	}
	return Reset(GOTO_HOOK);
}

int CCommands::Undo()
{
	if (CUtils::IsMicrosoftWord()) {
		static BOOL bIsCtrlDown;
		static BOOL bIsAltDown;
		static BOOL bIsShiftDown;

		bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
		bIsAltDown = CXkeymacsDll::IsDown(VK_MENU);
		bIsShiftDown = CXkeymacsDll::IsDown(VK_SHIFT);

		if (!bIsCtrlDown) {
			DepressKey(VK_CONTROL);
		}
		if (bIsAltDown) {
			ReleaseKey(VK_MENU);
		}
		if (bIsShiftDown) {
			ReleaseKey(VK_SHIFT);
		}

		PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);

		if (bIsShiftDown) {
			DepressKey(VK_SHIFT);
		}
		if (bIsAltDown) {
			DepressKey(VK_MENU);
		}
		if (!bIsCtrlDown) {
			ReleaseKey(VK_CONTROL);
		}

	} else {
		CXkeymacsDll::Original(CONTROL, 'Z', TRUE);
		CdKduCu('Z');
	}
	return Reset(GOTO_HOOK);
}

// C-x C-c: Alt-F4
int CCommands::SaveBuffersKillEmacs()
{
	ClearNumericArgument();
	if (CUtils::IsExplorer()) {
		AdKduAu(VK_F4);
	} else {
		AdKduAu(VK_SPACE, 'C');
	}
	return Reset(GOTO_HOOK);
}

int CCommands::IconifyOrDeiconifyFrame()
{
	ClearNumericArgument();
	AdKduAu(VK_SPACE, 'N');
	return Reset(GOTO_HOOK);
}

int CCommands::SetMarkCommand()
{
	ClearNumericArgument();
	if (CXkeymacsDll::IsDown(VK_SHIFT)) {
		ReleaseKey(VK_SHIFT);
		ClickCaret();
	}
	DepressKey(VK_SHIFT);
	m_bSetMark = TRUE;
	return Reset(GOTO_HOOK);
}

// C-g: Keyboard quit
int CCommands::KeyboardQuit()
{
	ClearNumericArgument();
	CString szDialogTitle;
	CUtils::GetFindDialogTitle(&szDialogTitle);
	if (!szDialogTitle.IsEmpty()) {
		Kdu(VK_ESCAPE);
	}
	if (m_bSetMark) {
		ReleaseKey(VK_SHIFT);
		m_bSetMark = FALSE;
		ClickCaret();
	}
	return Reset(GOTO_HOOK);
}

DWORD CCommands::ClickCaret()
{
	if (CUtils::IsMicrosoftWord()) {
		// GetCaretPos always returen (x,y) = (0,0) on M$ Word, so ...
		Kdu(VK_RIGHT);
		return ERROR_SUCCESS;	// i.e. return 0;
	}

	HWND hWnd = GetFocus();

	POINT CursorPos = {'\0'};
	if (!GetCursorPos(&CursorPos)) {
		return GetLastError();
	}

	POINT CaretPos = {'\0'};
	if (!GetCaretPos(&CaretPos)) {
		return GetLastError();
	}
	{
//		CString sz;
//		sz.Format("x = %d, y = %d", CaretPos.x, CaretPos.y);
//		AfxMessageBox(sz);
	}
	if (!ClientToScreen(hWnd, &CaretPos)) {
		return GetLastError();
	}
	{
//		CString sz;
//		sz.Format("x = %d, y = %d", CaretPos.x, CaretPos.y);
//		AfxMessageBox(sz);
	}

	if (!SetCursorPos(CaretPos.x, CaretPos.y + 1)) {
		return GetLastError();
	}
	mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, GetMessageExtraInfo());
	mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, GetMessageExtraInfo());
	if (!SetCursorPos(CursorPos.x, CursorPos.y)) {
		return GetLastError();
	}
	return ERROR_SUCCESS;	// i.e. return 0;
}

// C-x C-f: Alt-F, Alt-O
int CCommands::FindFile()
{
	ClearNumericArgument();
	CXkeymacsDll::Original(META, 'F', TRUE);
	AdKduAu('F', 'O');
	return Reset(GOTO_HOOK);
}

// C-i: Tab
int CCommands::TabToTabStop()
{
	ClearNumericArgument();
	Kdu(VK_TAB);
	return Reset(GOTO_HOOK);
}

// C-m: Enter
int CCommands::Enter()
{
	Kdu(VK_RETURN);
	return Reset(GOTO_HOOK);
}

// C-x C-p: Ctrl-End, Ctrl-Shift-Home
int CCommands::MarkPage()
{
	ClearNumericArgument();
	CdKduCu(VK_END);
	DepressKey(VK_SHIFT);
	CdKduCu(VK_HOME);
	ReleaseKey(VK_SHIFT);
	m_bSetMark = TRUE;
	return Reset(GOTO_HOOK);
}

// C-x C-s: Alt-F, Alt-S
int CCommands::SaveBuffer()
{
	ClearNumericArgument();
	if (CUtils::IsMicrosoftWord()) {
		// It works well only by C-s
		bC_x(FALSE);
		CXkeymacsDll::Original(CONTROL, 'S', TRUE);
		return Reset(GOTO_RECURSIVE);
	} else {
		// default
		CXkeymacsDll::Original(META, 'F', TRUE);
		AdKduAu('F', 'S');
		return Reset(GOTO_HOOK);
	}
}

// C-v: Page Down
int CCommands::ScrollUp()
{
	int rc = GOTO_HOOK;
//	if (CUtils::IsNotepad()) {
//		rc = ScrollUpDown(TRUE);
//	} else {
		Kdu(VK_NEXT);
//	}
	return rc;
}

// M-v: Page Up
int CCommands::ScrollDown()
{
	int rc = GOTO_HOOK;
//	if (CUtils::IsNotepad()) {
//		rc = ScrollUpDown(FALSE);
//	} else {
		Kdu(VK_PRIOR);
//	}
	return rc;
}

int CCommands::ScrollUpDown(BOOL bUp)
{
	static int nStep = 0;
	static HWND hWnd = NULL;
	static int nNewPos = 0;

	switch (nStep) {
	case 0:
		{
			hWnd = GetFocus();
			SCROLLINFO scrollinfo = {'\0'};
			scrollinfo.cbSize = sizeof(SCROLLINFO);
			scrollinfo.fMask = SIF_ALL;
			if (!GetScrollInfo(hWnd, SB_VERT, &scrollinfo)) {
//				CString sz;
//				sz.Format("GetScrollInfo: max = %d, page = %d, pos = %d, error = %d",
//						  scrollinfo.nMax, scrollinfo.nPage, scrollinfo.nPos, GetLastError());
//				AfxMessageBox(sz);
				goto DEFAULT;
			}

			int nScrollLines = scrollinfo.nPage - 2;	// number of lines to scroll per a M-v
			if (nScrollLines < 1) {
				nScrollLines = 1;
			}

			int nAllScrollLines;	// number of lines to scroll
			if (m_bDefaultNumericArgument) {
				nAllScrollLines = nScrollLines;
			} else {
				nAllScrollLines = nScrollLines * m_nNumericArgument;
			}
			int nOldPos = scrollinfo.nPos;
			if (bUp) {
				nNewPos = scrollinfo.nPos + nAllScrollLines;
				if ((int)(scrollinfo.nMax - scrollinfo.nPage + 1) < nNewPos) {
					nNewPos = scrollinfo.nMax - scrollinfo.nPage + 1;
				}
			} else {
				nNewPos = scrollinfo.nPos - nAllScrollLines;
				if (nNewPos < scrollinfo.nMin) {
					nNewPos = scrollinfo.nMin;
				}
			}
			nAllScrollLines = (int)fabs(nNewPos - nOldPos);

			RECT ClientRect;
			if (!GetClientRect(hWnd, &ClientRect)) {
//				AfxMessageBox("GetClientRect");
				goto DEFAULT;
			}

			POINT CaretPos = {'\0'};
			if (!GetCaretPos(&CaretPos)) {
//				AfxMessageBox("GetCaretPos");
				goto DEFAULT;
			}

			int nLineHight = ClientRect.bottom / (scrollinfo.nPage + 1);
			int nCaretLine = CaretPos.y / nLineHight;	// nCaretLine start from 0
			int nSpace = 0;	// space to scroll w/o hiding caret
			if (bUp) {
				nSpace = nCaretLine;
			} else {
				nSpace = scrollinfo.nPage - nCaretLine - 1;
			}
			if (scrollinfo.nPage == 1) {
				if (bUp) {
					Kdu(VK_DOWN);
					Kdu(VK_HOME);
				} else {
					Kdu(VK_UP);
					Kdu(VK_HOME);
				}
			} else {
				if (nSpace < nAllScrollLines) {	// move the caret
					if (bUp) {
						m_nNumericArgument = nAllScrollLines - nSpace;
						Kdu(VK_DOWN);
						Kdu(VK_HOME);
						if (m_nNumericArgument) {	// I do NOT understand why is this needed.
							Kdu(VK_DOWN);
						}
					} else {
//						CString sz;
//						sz.Format("all = %d, space = %d", nAllScrollLines, nSpace);
//						AfxMessageBox(sz);
						m_nNumericArgument = nAllScrollLines - nSpace;
						Kdu(VK_UP);
						Kdu(VK_HOME);
						if (m_nNumericArgument) {	// I do NOT understand why is this needed.
							Kdu(VK_UP);
						}
					}
				}
			}
		}
		nStep = 1;
		return Reset(GOTO_RECURSIVE);
		break;
	case 1:
		nStep = 0;
		SendMessage(hWnd, WM_VSCROLL, SB_THUMBPOSITION | (nNewPos * 0x10000), NULL);
		break;
	}
	return Reset(GOTO_HOOK);

DEFAULT:
	if (bUp) {
		Kdu(VK_NEXT);
	} else {
		Kdu(VK_PRIOR);
	}
	return Reset(GOTO_HOOK);
}

BOOL CCommands::bC_x()
{
	return m_bC_x;
}

void CCommands::bC_x(BOOL b)
{
	m_bC_x = b;
	CXkeymacsDll::ModifyShell_NotifyIcon(CX_ICON, m_bC_x);
}

// C-x: only set flag
int CCommands::C_x()
{
	bC_x(TRUE);
	return Reset(GOTO_HOOKX);
}

// C-x C-w: Alt-F, Alt-A
int CCommands::WriteFile()
{
	ClearNumericArgument();
	CXkeymacsDll::Original(META, 'F', TRUE);
	AdKduAu('F', 'A');
	return Reset(GOTO_HOOK);
}

// C-w: Ctrl-X
int CCommands::KillRegion()
{
	static int nStep = 0;
	switch (nStep) {
	case 0:
		ClearNumericArgument();
		CXkeymacsDll::Original(CONTROL, 'X', TRUE);
		CdKduCu('X');
		nStep = 1;
		return Reset(GOTO_RECURSIVE);
	case 1:
		nStep = 0;
		CXkeymacsDll::AddKillRing();
		ReleaseKey(VK_SHIFT);
		m_bSetMark = FALSE;
		return Reset(GOTO_HOOK);
	}
	// dummy
	return Reset(GOTO_HOOK);
}

// M-w: Ctrl-C
int CCommands::KillRingSave()
{
	static int nStep = 0;
	switch (nStep) {
	case 0:
		ClearNumericArgument();
		CdKduCu('C');
		nStep = 1;
		return Reset(GOTO_RECURSIVE);
	case 1:
		nStep = 0;
		CXkeymacsDll::AddKillRing();
		ReleaseKey(VK_SHIFT);
		m_bSetMark = FALSE;
		return Reset(GOTO_HOOK);
	}
	// dummy
	return Reset(GOTO_HOOK);
}

// C-y: Ctrl-V
int CCommands::Yank()
{
	if (!m_bDefaultNumericArgument) {
//		CXkeymacsDll::IncreaseKillRingIndex(m_nNumericArgument -1);
		DecreaseNumericArgument();
		CXkeymacsDll::IncreaseKillRingIndex(m_nNumericArgument);
		CXkeymacsDll::GetKillRing();
	}
	CXkeymacsDll::Original(CONTROL, 'V', TRUE);
	CdKduCu('V');
	ReleaseKey(VK_SHIFT);
	m_bSetMark = FALSE;
	return Reset(GOTO_HOOK);
}

// M-y: yank-pop
int CCommands::YankPop()
{
	ClearNumericArgument();
///	if (wLastParam == 'Y') {
		CXkeymacsDll::IncreaseKillRingIndex();
		CXkeymacsDll::GetKillRing();

		CXkeymacsDll::Original(CONTROL, 'Z', TRUE);
		CXkeymacsDll::Original(CONTROL, 'V', TRUE);
		CdKduCu('Z', 'V');
///	}
	return Reset(GOTO_HOOK);
}

// M-!: cmd.exe/command.com
int CCommands::ShellCommand()
{
	ClearNumericArgument();
	STARTUPINFO si = {'\0'};
	PROCESS_INFORMATION pi = {'\0'};
	char *terminal = getenv("COMSPEC");
	if (terminal) {
		CreateProcess(NULL, terminal, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
	}
	return Reset(GOTO_HOOK);
}

int CCommands::Ignore()
{
	return Reset(GOTO_HOOK);
}

void CCommands::bM_(BOOL b)
{
	m_bM_ = b;
	CXkeymacsDll::ModifyShell_NotifyIcon(META_ICON, m_bM_);
}

BOOL CCommands::bM_()
{
	return m_bM_;
}

int CCommands::Meta()
{
	bM_(TRUE);
	return Reset(GOTO_HOOKX);
}

int CCommands::MetaEscape()
{
	Meta();
	return Reset(GOTO_DO_NOTHING);
}

int CCommands::MetaAlt()
{
	return Reset(GOTO_DO_NOTHING);
}

int CCommands::NumericArgument0()
{
	return NumericArgument(0);
}

int CCommands::NumericArgument1()
{
	return NumericArgument(1);
}

int CCommands::NumericArgument2()
{
	return NumericArgument(2);
}

int CCommands::NumericArgument3()
{
	return NumericArgument(3);
}

int CCommands::NumericArgument4()
{
	return NumericArgument(4);
}

int CCommands::NumericArgument5()
{
	return NumericArgument(5);
}

int CCommands::NumericArgument6()
{
	return NumericArgument(6);
}

int CCommands::NumericArgument7()
{
	return NumericArgument(7);
}

int CCommands::NumericArgument8()
{
	return NumericArgument(8);
}

int CCommands::NumericArgument9()
{
	return NumericArgument(9);
}

int CCommands::NumericArgument(int n)
{
	if (m_bDefaultNumericArgument) {
		m_nNumericArgument = n;
		m_bDefaultNumericArgument = FALSE;
	} else {
		m_nNumericArgument = m_nNumericArgument * 10 + n;
	}
	return Reset(GOTO_HOOK0_9);
}

int CCommands::NumericArgumentMinus()
{
	m_bNegativeNumericArgument = !m_bNegativeNumericArgument;
	return Reset(GOTO_HOOK0_9);
}

int CCommands::UniversalArgument()
{
	if (m_bC_u) {
		m_nNumericArgument *= 4;
	} else {
		m_nNumericArgument = 4;
		m_bC_u = TRUE;
	}
	return Reset(GOTO_HOOKX);
}

// change function name and member variable name like bUniversalArgument()
BOOL CCommands::bC_u()
{
	return m_bC_u;
}

void CCommands::bC_u(BOOL b)
{
	m_bC_u = b;
}

int CCommands::Repeat(BYTE bVk)
{
	if (m_bDefaultNumericArgument) {
		return Reset(GOTO_DO_NOTHING);
	} else {
		CXkeymacsDll::Kdu(bVk, m_nNumericArgument);
		return Reset(GOTO_HOOK);
	}
}

// C-l: Recenter
int CCommands::Recenter()
{
	if (CUtils::IsBecky()) {
		static int nStep = 0;
		RECT ClientRect;
		GetClientRect(GetFocus(), &ClientRect);
		static int gap = INT_MAX;

		static POINT CaretPos;
		GetCaretPos(&CaretPos);

		switch (nStep) {
		case 0:
			nStep = 0;	// omaginai
			if (CaretPos.y < ClientRect.bottom / 2) {
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
			} else if (ClientRect.bottom / 2 < CaretPos.y) {
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
			} else {
				gap = INT_MAX;
				return Reset(GOTO_HOOK);
				break;
			}

			Kdu(VK_DOWN);
			nStep = 1;
			return Reset(GOTO_RECURSIVE);

		case 1:
			nStep = 0;
			// When a client screen can display 2n lines, the center line is (n + 1)th line.
			int newgap = CaretPos.y - ClientRect.bottom / 2;
			if (fabs(gap) <= fabs(newgap)) {
				if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0) {
					SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
				}
				gap = INT_MAX;
				return Reset(GOTO_HOOK);
				break;
			}

			gap = newgap;
			return Reset(GOTO_RECURSIVE);
		}
	} else {
		RECT ClientRect;
		GetClientRect(GetFocus(), &ClientRect);
		int gap = INT_MAX;

		for (;;) {
			POINT CaretPos;
			GetCaretPos(&CaretPos);

			if (CaretPos.y < ClientRect.bottom / 2) {
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
			} else if (ClientRect.bottom / 2 < CaretPos.y) {
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
			} else {
				break;
			}

			// When a client screen can display 2n lines, the center line is (n + 1)th line.
			int newgap = CaretPos.y - ClientRect.bottom / 2;
			if (fabs(gap) <= fabs(newgap)) {
				if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0) {
					SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
				}
				break;
			}
			gap = newgap;
		}
		return Reset(GOTO_HOOK);
	}
	return Reset(GOTO_HOOK);
}

// C-t: Shift-Left, Shift-Delete, Right Shift-Insert, if the cursor is not at EOL (is End Of Line)
//		Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right, if the cursor is at EOL
int CCommands::TransposeChars()
{
	ClearNumericArgument();	// tmp

	static CString szOriginalClipboardText;
	// Do not try to do these command at once.
	// Clipboard has old data till you go out this function.
	static int nStep = 0;
	switch (nStep) {
	case 0:
///		if (wLastParam != 'T') {
///			CancelSelection();
///		}
		szOriginalClipboardText.Empty();
		if (!CUtils::GetClipboardText(&szOriginalClipboardText)) {
			szOriginalClipboardText.Empty();
		}
//		AfxMessageBox(szOriginalClipboardText);

		// simple version
		if (CUtils::IsLotus123()) {
			// C-t: Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right
			Kdu(VK_LEFT);
			SdKduSu(VK_RIGHT, VK_DELETE);
			Kdu(VK_LEFT);
			SdKduSu(VK_INSERT);
			Kdu(VK_RIGHT);
			nStep = 3;
			return Reset(GOTO_RECURSIVE);
			break;	// needless
		}
				
		if (!CopyBackCharacter()) {
			return Reset(GOTO_DO_NOTHING);
		}

		nStep = 1;
		return Reset(GOTO_RECURSIVE);
		break;	// needless
	case 1:
		{
			nStep = 0;
			CString szClipboardText;
			CUtils::GetClipboardText(&szClipboardText);

//			CString sz;
//			sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//			AfxMessageBox(sz);

			// Top Of File
			if (szClipboardText.IsEmpty() ||		// for normal application
				szClipboardText.GetLength() >= 3) {	// for VC++
				Kdu(VK_LEFT);
				nStep = 3;
				return Reset(GOTO_RECURSIVE);
			}

			if (!CopyNextCharacter()) {
				nStep = 3;
				return Reset(GOTO_RECURSIVE);
			}

			nStep = 2;
			return Reset(GOTO_RECURSIVE);
			break;	// needless
		}
	case 2:
		{
			nStep = 0;
			CString szClipboardText;
			CUtils::GetClipboardText(&szClipboardText);

//			CString sz;
//			sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//			AfxMessageBox(sz);

			if (!szClipboardText.IsEmpty() &&
				szClipboardText.GetAt(0) != VK_RETURN) {
				SdKduSu(VK_LEFT, VK_DELETE);
				Kdu(VK_RIGHT);
				nStep = 10;
				return Reset(GOTO_RECURSIVE);
				SdKduSu(VK_INSERT);
			} else {
				if (szClipboardText.IsEmpty()) {	// EOF
					if (CUtils::IsMicrosoftWord() ||
						CUtils::IsMicrosoftFrontPage() ||
						CUtils::IsLotusNotes() ||
						CUtils::IsLotusWordPro()    ) {
						// These applications say "EOL is EOF".
						Kdu(VK_END);
					} else {
						// default
						Kdu(VK_RIGHT);
					}
				}

				nStep = 11;
				return Reset(GOTO_RECURSIVE);
				SdKduSu(VK_INSERT);
				Kdu(VK_RIGHT);
			}

			nStep = 3;
			return Reset(GOTO_RECURSIVE);
			break;	// needless
		}
	case 10:
		nStep = 0;
		SdKduSu(VK_INSERT);
		nStep = 3;
		return Reset(GOTO_RECURSIVE);
	case 11:
		nStep = 0;
//		Kdu(VK_LEFT);
//		SdKduSu(VK_RIGHT, VK_DELETE);
		SdKduSu(VK_LEFT, VK_DELETE);
		Kdu(VK_LEFT);
		nStep = 12;
		return Reset(GOTO_RECURSIVE);
	case 12:
		nStep = 0;
		SdKduSu(VK_INSERT);
		Kdu(VK_RIGHT);
		nStep = 3;
		return Reset(GOTO_RECURSIVE);
	case 3:
		nStep = 0;
		if (!CUtils::SetClipboardText(&szOriginalClipboardText)) {
			//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
		}
		return Reset(GOTO_HOOK);
		break;	// needless
	}
	return Reset(GOTO_HOOK);
}

// Copy next character of the cursor if the caret is NOT at end of the file
// Move the caret to left if caret is at end of the file
BOOL CCommands::CopyNextCharacter()
{
	if (!OpenClipboard(NULL)) {
		return FALSE;
	}
	if (!EmptyClipboard()) {
		return FALSE;
	}
	if (!CloseClipboard()) {
		return FALSE;
	}

	SdKduSu(VK_RIGHT);
	CdKduCu('C');
	Kdu(VK_LEFT);

	return TRUE;
}

BOOL CCommands::CopyBackCharacter()
{
	if (!OpenClipboard(NULL)) {
		return FALSE;
	}
	if (!EmptyClipboard()) {
		return FALSE;
	}
	if (!CloseClipboard()) {
		return FALSE;
	}

	SdKduSu(VK_LEFT);
	CdKduCu('C');
	Kdu(VK_RIGHT);

	return TRUE;
}

DWORD CCommands::CancelSelection()
{
	if (m_bSetMark) {
		ReleaseKey(VK_SHIFT);
		m_bSetMark = FALSE;
	}
	return ClickCaret();
}

void CCommands::DecreaseNumericArgument()
{
	if (m_bNegativeNumericArgument) {
		m_nNumericArgument++;
	} else {
		if (m_nNumericArgument == 0) {
			m_nNumericArgument++;
			m_bNegativeNumericArgument = TRUE;
		} else {
			m_nNumericArgument--;
		}
	}
}

void CCommands::ClearNumericArgument()
{
	m_bDefaultNumericArgument = TRUE;
	m_nNumericArgument = 1;
	m_bNegativeNumericArgument = FALSE;
}

void CCommands::Reset()
{
	Reset(GOTO_HOOK);
}

int CCommands::Reset(int rc)
{
	switch(rc) {
	case GOTO_HOOK:
		ClearNumericArgument();
		m_bC_u = FALSE;
	case GOTO_HOOK0_9:
		bC_x(FALSE);
		bM_(FALSE);
	case GOTO_HOOKX:
		break;

	case GOTO_RECURSIVE:
		break;

	case GOTO_DO_NOTHING:
		break;

	default:
		break;
	}
	return rc;
}

int CCommands::IsearchBackward()
{
	ClearNumericArgument();
	Search(BACKWARD);
	return Reset(GOTO_HOOK);
}

int CCommands::IsearchForward()
{
	ClearNumericArgument();
	Search(FORWARD);
	return Reset(GOTO_HOOK);
}

int CCommands::EnableOrDisableXKeymacs()
{
	// dummy
	return Reset(GOTO_HOOK);
}

int CCommands::GetNumericArgument()
{
	return m_nNumericArgument;
}

void CCommands::Search(SEARCH_DIRECTION direction)
{
	if ((direction != FORWARD) && (direction != BACKWARD)) {
		ASSERT(0);
	}

	CSearch *pSearch;
	pSearch = new CSearch();

	if (pSearch->m_szDialogTitle.IsEmpty()) {
		// Find Dialog is not.
		// Open Find dialog
		if ((CUtils::IsNotepad() &&
			 CUtils::IsNTor9x()) ||
			CUtils::IsK2Editor()) {
			// notepad on Win9x or NT
			CXkeymacsDll::Original(META, 'F', TRUE);
			AdKduAu('S', 'F');
		} else if (CUtils::IsSakuraEditor()) {
			AdKduAu('S', VK_RETURN);
		} else if (CUtils::IsDirector()) {
			CXkeymacsDll::Original(META, 'E', TRUE);
			CXkeymacsDll::Original(META, 'F', TRUE);
			CXkeymacsDll::Original(META, 'T', TRUE);
			AdKduAu('E', 'F', 'T');
		} else if (CUtils::IsOutlookExpress() ||
				   CUtils::IsDWFM() ||
				   CUtils::IsEggExplorer() ||
				   CUtils::IsExplorer()) {
			Kdu(VK_F3);
		} else if (CUtils::IsOpera() ||
				   CUtils::IsHidemaru() ||
				   CUtils::IsNetscape() ||
				   CUtils::IsMozilla()) {
			CXkeymacsDll::Original(CONTROL, 'F', TRUE);
			CdKduCu('F');
		} else {
			// default
//			Original(CONTROL, 'F', TRUE);
//			Kdu('F');
			CXkeymacsDll::Original(META, 'F', TRUE);
			AdKduAu('E', 'F');
		}

		// Set Direction w/o with sakura.exe if Find dialog already exist
		if (CUtils::IsSakuraEditor() ||
			CUtils::IsLotusWordPro() ||
			CUtils::IsHidemaru() ||
			CUtils::IsNetscape() ||
			CUtils::IsMozilla() ||
			CUtils::IsDWFM() ||
			CUtils::IsK2Editor() ||
			CUtils::IsEggExplorer() ||
			CUtils::IsExplorer()) {
		} else if (CUtils::IsInternetExplorer()) {
			// I want to set direction but IE does not allow me.
		} else {
			// default
			SearchSetDirection(direction, pSearch);
		}
		m_SearchDirection = direction;
	} else {
		// Find Dialog is opened.
		if (CUtils::IsSakuraEditor() ||
			CUtils::IsHidemaru() ||
			CUtils::IsK2Editor()) {
			BYTE bDirection = 0;

			if (direction == FORWARD) {
				bDirection = pSearch->m_pKey->m_bDirectionForward;
			} else if (direction == BACKWARD) {
				bDirection = pSearch->m_pKey->m_bDirectionBackward;
			} else {
				ASSERT(0);
			}
			AdKduAu(bDirection);
		} else {
			if (m_SearchDirection != direction) {
				// Set Direction if Find dialog already exist
				SearchSetDirection(direction, pSearch);
				m_SearchDirection = direction;
				return;
			}

			// "Find Next(F)" if Find dialog already exist
			Kdu(VK_RETURN);

			// open Find dialog again
			if (CUtils::IsOutlook() &&
				pSearch->m_szDialogTitle.Compare("")) {
				// Outlook (w/o Japanese version)
				CXkeymacsDll::Original(META, 'F', TRUE);
				AdKduAu('E', 'F');
			} else if (CUtils::IsVisualCpp()) {
				CXkeymacsDll::Original(CONTROL, 'F', TRUE);
				CdKduCu('F');
				DepressKey(VK_CONTROL);		// Why is this need???
			} else if (CUtils::IsBecky()) {
//				CXkeymacsDll::Original(META, 'F', TRUE);
//				AdKduAu('E', 'F');
//				CXkeymacsDll::Original(CONTROL, 'F', TRUE);
//				CdKduCu('F');
			}

			// set cursor at end of FindWhat
			if (CUtils::IsBecky()) {
//				Kdu(VK_TAB, 4);
//				Kdu(VK_DOWN);
			} else if (CUtils::IsNetscape() ||
					   CUtils::IsMozilla()) {
				// do nothing
			} else if (CUtils::IsMicrosoftWord()) {
//				BOOL bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
//				if (bIsCtrlDown) {
				{
					BYTE ks[256];
					GetKeyboardState( ks );
					ks[ VK_CONTROL ] = 0;
					SetKeyboardState( ks );

					ReleaseKey(VK_CONTROL);
				}
				AdKduAu('N');
				Kdu(VK_ESCAPE);
				Kdu(VK_END);

//				if (bIsCtrlDown) {
				{
					DepressKey(VK_CONTROL);

					BYTE ks[256];
					GetKeyboardState( ks );
					ks[ VK_CONTROL ] = 1;
					SetKeyboardState( ks );
				}
			} else {
				if (pSearch->m_pKey->m_bFindWhat == 'F') {
					CXkeymacsDll::Original(META, 'F', TRUE);
				}
				AdKduAu(pSearch->m_pKey->m_bFindWhat);
			}
			Kdu(VK_END);
		}
	}
	delete pSearch;
}

void CCommands::SearchSetDirection(SEARCH_DIRECTION direction, CSearch *pSearch)
{
	if ((direction != FORWARD) && (direction != BACKWARD)) {
		ASSERT(0);
	}

	if (pSearch->m_pKey->m_bDirectionForward == 0 && pSearch->m_pKey->m_bDirectionBackward == 0) {
		return;
	} else if (CUtils::IsMicrosoftWord()) {
//		BOOL bIsCtrlDown = CXkeymacsDll::IsDown(VK_CONTROL);
//		if (bIsCtrlDown) {
		{
			BYTE ks[256];
			GetKeyboardState( ks );
			ks[ VK_CONTROL ] = 0;
			SetKeyboardState( ks );

			ReleaseKey(VK_CONTROL);
		}

		AdKduAu('M');
		AdKduAu(0xBA);	// VK_OEM_1	Used for miscellaneous characters; it can vary by keyboard. 
							//			Windows 2000/XP: For the US standard keyboard, the ';:' key
		Kdu(VK_UP, VK_UP);
		if (direction == BACKWARD) {
			Kdu(VK_DOWN);
		}
		AdKduAu('N');
		Kdu(VK_ESCAPE);
		Kdu(VK_END);

//		if (bIsCtrlDown) {
		{
			DepressKey(VK_CONTROL);

			BYTE ks[256];
			GetKeyboardState( ks );
			ks[ VK_CONTROL ] = 1;
			SetKeyboardState( ks );
		}
	} else if (CUtils::IsLotusNotes()) {
		BYTE bDirection	= 0;

		if (direction == FORWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionForward;
		} else if (direction == BACKWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionBackward;
		}

		if (bDirection == 'B') {
			CXkeymacsDll::Original(META, 'B', TRUE);
		}
		AdKduAu(pSearch->m_pKey->m_bSearchOption, bDirection, pSearch->m_pKey->m_bSearchOption);
		{
			CString szDialogTitle;
			CUtils::GetFindDialogTitle(&szDialogTitle);

			if (!szDialogTitle.Compare("") ||
				!szDialogTitle.Compare("Find")) {
				SdKduSu(VK_TAB);
			} else {
				SdKduSu(VK_TAB, VK_TAB);
			}
		}
		Kdu(VK_END);
	} else if (CUtils::IsBecky()) {
		AdKduAu(pSearch->m_pKey->m_bDirectionForward);
		if (direction == BACKWARD) {
			Kdu(VK_UP);
		}
		Kdu(VK_TAB, 4);
		Kdu(VK_END);
	} else if (CUtils::IsNetscape() ||
			   CUtils::IsMozilla()) {
		Kdu(VK_TAB, 3);
		Kdu(VK_SPACE);
		SdKduSu(VK_TAB, 3);
	} else {
		// default
		BYTE bDirection	= 0;
	
		if (direction == FORWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionForward;
		} else if (direction == BACKWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionBackward;
		}

		if (pSearch->m_pKey->m_bFindWhat == 'F') {
			CXkeymacsDll::Original(META, 'F', TRUE);
		}
		if (bDirection == 'B') {
			CXkeymacsDll::Original(META, 'B', TRUE);
		}
//		CString sz;
//		sz.Format("%c, %c", bDirection, pSearch->m_pKey->m_bFindWhat);
//		AfxMessageBox(sz);
		AdKduAu(bDirection, pSearch->m_pKey->m_bFindWhat);
	}
}

void CCommands::SearchDirection(SEARCH_DIRECTION direction)
{
	m_SearchDirection = direction;
}

// C-x C-j, C-o, C-\, C-BACKSLASH
int CCommands::ToggleInputMethod()
{
	SetInputMethodOpenStatus(TOGGLE_INPUT_METHOD);
	return Reset(GOTO_HOOK);
}

int CCommands::OpenInputMethod()
{
	SetInputMethodOpenStatus(OPEN_INPUT_METHOD);
	return Reset(GOTO_HOOK);
}

int CCommands::CloseInputMethod()
{
	SetInputMethodOpenStatus(CLOSE_INPUT_METHOD);
	return Reset(GOTO_HOOK);
}

void CCommands::SetInputMethodOpenStatus(INPUT_METHOD_OPEN_STATUS status)
{
	ClearNumericArgument();
	HKL hKL = GetKeyboardLayout(0);
	if (ImmIsIME(hKL)) {
		// default
		HWND hWnd = GetFocus();
		HIMC hIMC = ImmGetContext(hWnd);
		switch (status) {
		case CLOSE_INPUT_METHOD:
			ImmSetOpenStatus(hIMC, FALSE);
			break;
		case OPEN_INPUT_METHOD:
			ImmSetOpenStatus(hIMC, TRUE);
			break;
		case TOGGLE_INPUT_METHOD:
			ImmSetOpenStatus(hIMC, !ImmGetOpenStatus(hIMC));
			break;
		default:
			ASSERT(0);
			break;
		}

		ImmReleaseContext(hWnd, hIMC);
	} else {
		Kdu(VK_KANJI);
	}
}
