// Commands.h: interface of the CCommands class
//
//////////////////////////////////////////////////////////////////////

#include "xkeymacsdll.h"

#if !defined(AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_)
#define AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum SEARCH_DIRECTION { NA, FORWARD, BACKWARD };
enum INPUT_METHOD_OPEN_STATUS {CLOSE_INPUT_METHOD, OPEN_INPUT_METHOD, TOGGLE_INPUT_METHOD};

class CCommands  
{
public:
	static int Reset(int rc);
	static int CloseInputMethod();
	static int OpenInputMethod();
	static void SearchDirection(SEARCH_DIRECTION direction);
	static int NumericArgument(int n);
	static void ClearNumericArgument();
	static int GetNumericArgument();
	static int EnableOrDisableXKeymacs();
	static int IsearchForward();
	static int IsearchBackward();
	static int TransposeChars();
	static int Recenter();
	static int Repeat(BYTE bVk);
	static void bC_u(BOOL b);
	static BOOL bC_u();
	static int UniversalArgument();
	static int NumericArgumentMinus();
	static int NumericArgument9();
	static int NumericArgument8();
	static int NumericArgument7();
	static int NumericArgument6();
	static int NumericArgument5();
	static int NumericArgument4();
	static int NumericArgument3();
	static int NumericArgument2();
	static int NumericArgument1();
	static int NumericArgument0();
	static int MetaAlt();
	static int MetaEscape();
	static int Meta();
	static void bM_(BOOL b);
	static BOOL bM_();
	static int Ignore();
	static int ShellCommand();
	static int YankPop();
	static int Yank();
	static int KillRingSave();
	static int KillRegion();
	static int WriteFile();
	static int C_x();
	static void Reset();
	static void bC_x(BOOL b);
	static BOOL bC_x();
	static int ScrollDown();
	static int ScrollUp();
	static int SaveBuffer();
	static int MarkPage();
	static int Enter();
	static int TabToTabStop();
	static int FindFile();
	static int KeyboardQuit();
	static int SetMarkCommand();
	static int IconifyOrDeiconifyFrame();
	static int SaveBuffersKillEmacs();
	static int Undo();
	static int KillLine();
	static int DeleteChar();
	static int DeleteBackwardChar();
	static int EndOfBuffer();
	static int BeginningOfBuffer();
	static int QueryReplaceRegexp();
	static int QueryReplace();
	static int ToggleInputMethod();
	static int OpenLine();
	static int PreviousLine();
	static int NextLine();
	static int BackwardWord();
	static int ForwardWord();
	static int EndOfLine();
	static int BackwardChar();
	static int BeginningOfLine();
	static int ForwardChar();
	CCommands();
	virtual ~CCommands();

protected:
	static void SetInputMethodOpenStatus(INPUT_METHOD_OPEN_STATUS status);
	static void SearchSetDirection(SEARCH_DIRECTION direction, CSearch *pSearch);
	static SEARCH_DIRECTION m_SearchDirection;
	static void Search(SEARCH_DIRECTION direction);
	static void DecreaseNumericArgument();
	static DWORD CancelSelection();
	static BOOL CopyBackCharacter();
	static BOOL CopyNextCharacter();
	static BOOL m_bC_u;
	static BOOL m_bNegativeNumericArgument;
	static BOOL m_bDefaultNumericArgument;
	static BOOL m_bM_;
	static BOOL m_bC_x;
	static int ScrollUpDown(BOOL bUp);
	static DWORD ClickCaret();
	static BOOL m_bSetMark;
	static void ReleaseKey(BYTE bVk);
	static void DepressKey(BYTE bVk);
	static void SdKduSu(BYTE bVk1, BYTE bVk2 = 0);
	static void AdKduAu(BYTE bVk1, BYTE bVk2 = 0, BYTE bVk3 = 0);
	static void CdKduCu(BYTE bVk1, BYTE bVk2 = 0);
	static void Kdu(BYTE bVk1, BYTE bVk2 = 0, BYTE bVk3 = 0);
	static DWORD m_nNumericArgument;
};

typedef struct KeyBind
{
	int nCommandType;
	BYTE bVk;
	int nControlID;
} KeyBind_t;

enum { MAX_KEY_BIND = 8 };

typedef struct Command
{
	char *szCommandName;
	int nCategoryID;
	int (*fCommand)();
	KeyBind_t keybind[MAX_KEY_BIND];
} Command_t;

#include "../xkeymacs/resource.h"

static const Command_t Commands[] = {
	{"[unassigned]",				0,				NULL,								{'\0'}},
	{"C-x",							0,				CCommands::C_x,						{'\0'}},
	{"Close input method",			IDS_IME,		CCommands::CloseInputMethod,		{'\0'}},
	{"Enable or disable XKeymacs",	IDS_OTHER,		CCommands::EnableOrDisableXKeymacs,	{{CONTROL, 'Q', IDC_CQ},
																						 {CONTROL+SHIFT, 'Q', IDC_CQ},
																						 {'\0'}}},
	{"Enter",						IDS_OTHER,		CCommands::Enter,					{{CONTROL, 'M', IDC_CM},
																						 {CONTROL+SHIFT, 'M', IDC_CM},
																						 {'\0'}}},
	{"Ignore",						IDS_OTHER,		CCommands::Ignore,					{'\0'}},
	{"Meta",						IDS_OTHER,		CCommands::Meta,					{{CONTROL, 0xDB, IDC_SQUARE_BRA},
																						 {CONTROL+SHIFT, 0xDB, IDC_ALT},
																						 {'\0'}}},	// VK_OEM_4
	{"Meta for Alt",				IDS_OTHER,		CCommands::MetaAlt,					{{NONE, VK_MENU, IDC_ALT},
																						 {NONE, VK_LMENU, IDC_LEFT_ALT},
																						 {NONE, VK_RMENU, IDC_RIGHT_ALT},
																						{'\0'}}},
	{"Meta for Escape",				IDS_OTHER,		CCommands::MetaEscape,				{{NONE, VK_ESCAPE, IDC_ESCAPE},
																						 {'\0'}}},	// add SHIFT
	{"Open Input Method",			IDS_IME,		CCommands::OpenInputMethod,			{'\0'}},
	{"backward-char",				IDS_MOTION,		CCommands::BackwardChar,			{{CONTROL, 'B', IDC_CB},
																						 {CONTROL+SHIFT, 'B', IDC_CB},
																						 {'\0'}}},
	{"backward-word",				IDS_MOTION,		CCommands::BackwardWord,			{{META, 'B', IDC_MB},
																						 {META+SHIFT, 'B', IDC_MB},
																						 {'\0'}}},
	{"beginning-of-buffer",			IDS_MOTION,		CCommands::BeginningOfBuffer,		{{META, 0xBC, IDC_MSCOMMA},
																						 {META+SHIFT, 0xBC, IDC_MSCOMMA},
																						 {'\0'}}},	// VK_OEM_COMMA
	{"beginning-of-line",			IDS_MOTION,		CCommands::BeginningOfLine,			{{CONTROL, 'A', IDC_CA},
																						 {CONTROL+SHIFT, 'A', IDC_CA},
																						 {'\0'}}},
	{"delete-backward-char",		IDS_KILL,		CCommands::DeleteBackwardChar,		{{CONTROL, 'H', IDC_CH},
																						 {CONTROL+SHIFT, 'H', IDC_CH},
																						 {'\0'}}},
	{"delete-char",					IDS_KILL,		CCommands::DeleteChar,				{{CONTROL, 'D', IDC_CD},
																						 {CONTROL+SHIFT, 'D', IDC_CD},
																						 {'\0'}}},
	{"end-of-buffer",				IDS_MOTION,		CCommands::EndOfBuffer,				{{META, 0xBE, IDC_MSPERIOD},
																						 {META+SHIFT, 0xBE, IDC_MSPERIOD},
																						 {'\0'}}},	// VK_OEM_PERIOD
	{"end-of-line",					IDS_MOTION,		CCommands::EndOfLine,				{{CONTROL, 'E', IDC_CE},
																						 {CONTROL+SHIFT, 'E', IDC_CE},
																						 {'\0'}}},
	{"find-file",					IDS_FILES,		CCommands::FindFile,				{{CONTROL+CONTROLX, 'F', IDC_CXCF},
																						 {CONTROL+SHIFT+CONTROLX, 'F', IDC_CXCF},
																						 {'\0'}}},
	{"forward-char",				IDS_MOTION,		CCommands::ForwardChar,				{{CONTROL, 'F', IDC_CF},
																						 {CONTROL+SHIFT, 'F', IDC_CF},
																						 {'\0'}}},
	{"forward-word",				IDS_MOTION,		CCommands::ForwardWord,				{{META, 'F', IDC_MF},
																						 {META+SHIFT, 'F', IDC_MF},
																						 {'\0'}}},
	{"iconify-or-deiconify-frame",	IDS_WINDOW,		CCommands::IconifyOrDeiconifyFrame,	{{CONTROL, 'Z', IDC_CZ},
																						 {CONTROL+SHIFT, 'Z', IDC_CZ},
																						 {'\0'}}},
	{"isearch-backward",			IDS_SEARCH,		CCommands::IsearchBackward,			{{CONTROL, 'R', IDC_CR},
																						 {CONTROL+SHIFT, 'R', IDC_CR},
																						 {'\0'}}},
	{"isearch-forward",				IDS_SEARCH,		CCommands::IsearchForward,			{{CONTROL, 'S', IDC_CS},
																						 {CONTROL+SHIFT, 'S', IDC_CS},
																						 {'\0'}}},
	{"keyboard-quit",				IDS_OTHER,		CCommands::KeyboardQuit,			{{CONTROL, 'G', IDC_CG},
																						 {CONTROL+SHIFT, 'G', IDC_CG},
																						 {'\0'}}},
	{"kill-line",					IDS_KILL,		CCommands::KillLine,				{{CONTROL, 'K', IDC_CK},
																						 {CONTROL+SHIFT, 'K', IDC_CK},
																						 {'\0'}}},
	{"kill-region",					IDS_KILL,		CCommands::KillRegion,				{{CONTROL, 'W', IDC_CW},
																						 {CONTROL+SHIFT, 'W', IDC_CW},
																						 {'\0'}}},
	{"kill-ring-save",				IDS_KILL,		CCommands::KillRingSave,			{{META, 'W', IDC_MW},
																						 {META+SHIFT, 'W', IDC_MW},
																						 {'\0'}}},
	{"mark-page",					IDS_OTHER,		CCommands::MarkPage,				{{CONTROL+CONTROLX, 'P', IDC_CXCP},
																						 {CONTROL+SHIFT+CONTROLX, 'P', IDC_CXCP},
																						 {'\0'}}},
	{"next-line",					IDS_MOTION,		CCommands::NextLine,				{{CONTROL, 'N', IDC_CN},
																						 {CONTROL+SHIFT, 'N', IDC_CN},
																						 {'\0'}}},
	{"numeric argument 0",			IDS_OTHER,		CCommands::NumericArgument0,		{{CONTROL, '0', IDC_CDIGIT},
																						 {META, '0', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 1",			IDS_OTHER,		CCommands::NumericArgument1,		{{CONTROL, '1', IDC_CDIGIT},
																						 {META, '1', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 2",			IDS_OTHER,		CCommands::NumericArgument2,		{{CONTROL, '2', IDC_CDIGIT},
																						 {META, '2', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 3",			IDS_OTHER,		CCommands::NumericArgument3,		{{CONTROL, '3', IDC_CDIGIT},
																						 {META, '3', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 4",			IDS_OTHER,		CCommands::NumericArgument4,		{{CONTROL, '4', IDC_CDIGIT},
																						 {META, '4', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 5",			IDS_OTHER,		CCommands::NumericArgument5,		{{CONTROL, '5', IDC_CDIGIT},
																						 {META, '5', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 6",			IDS_OTHER,		CCommands::NumericArgument6,		{{CONTROL, '6', IDC_CDIGIT},
																						 {META, '6', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 7",			IDS_OTHER,		CCommands::NumericArgument7,		{{CONTROL, '7', IDC_CDIGIT},
																						 {META, '7', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 8",			IDS_OTHER,		CCommands::NumericArgument8,		{{CONTROL, '8', IDC_CDIGIT},
																						 {META, '8', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument 9",			IDS_OTHER,		CCommands::NumericArgument9,		{{CONTROL, '9', IDC_CDIGIT},
																						 {META, '9', IDC_CDIGIT},
																						 {'\0'}}},
	{"numeric argument -",			IDS_OTHER,		CCommands::NumericArgumentMinus,	{{CONTROL, 0xBD, IDC_CDIGIT},
																						 {META, 0xBD, IDC_CDIGIT},
																						 {'\0'}}},
	{"open-line",					IDS_OTHER,		CCommands::OpenLine,				{{CONTROL, 'O', IDC_CO},
																						 {CONTROL+SHIFT, 'O', IDC_CO},
																						 {'\0'}}},
	{"previous-line",				IDS_MOTION,		CCommands::PreviousLine,			{{CONTROL, 'P', IDC_CP},
																						 {CONTROL+SHIFT, 'P', IDC_CP},
																						{'\0'}}},
	{"query-replace",				IDS_SEARCH,		CCommands::QueryReplace,			{{META+SHIFT, '5', IDC_MS5},
																						 {'\0'}}},
	{"query-replace-regexp",		IDS_SEARCH,		CCommands::QueryReplaceRegexp,		{{CONTROL+META+SHIFT, '5', IDC_CMS5},
																						 {'\0'}}},
	{"recenter",					IDS_OTHER,		CCommands::Recenter,				{{CONTROL, 'L', IDC_CL},
																						 {CONTROL+SHIFT, 'L', IDC_CL},
																						 {'\0'}}},
	{"save-buffer",					IDS_FILES,		CCommands::SaveBuffer,				{{CONTROL+CONTROLX, 'S', IDC_CXCS},
																						 {CONTROL+SHIFT+CONTROLX, 'S', IDC_CXCS},
																						 {'\0'}}},
	{"save-buffers-kill-emacs",		IDS_WINDOW,		CCommands::SaveBuffersKillEmacs,	{{CONTROL+CONTROLX, 'C', IDC_CXCC},
																						 {CONTROL+SHIFT+CONTROLX, 'C', IDC_CXCC},
																						 {'\0'}}},
	{"scroll-down",					IDS_MOTION,		CCommands::ScrollDown,				{{META, 'V', IDC_MV},
																						 {META+SHIFT, 'V', IDC_MV},
																						 {'\0'}}},
	{"scroll-up",					IDS_MOTION,		CCommands::ScrollUp,				{{CONTROL, 'V', IDC_CV},
																						 {CONTROL+SHIFT, 'V', IDC_CV},
																						 {'\0'}}},
	{"set-mark-command",			IDS_OTHER,		CCommands::SetMarkCommand,			{{CONTROL, VK_SPACE, IDC_CSPACE},
																						 {CONTROL+SHIFT, VK_SPACE, IDC_CSPACE},
																						 {'\0'}}},
	{"shell-command",				IDS_OTHER,		CCommands::ShellCommand,			{{META+SHIFT, '1', IDC_MS1},
																						 {'\0'}}},
	{"tab-to-tab-stop",				IDS_OTHER,		CCommands::TabToTabStop,			{{CONTROL, 'I', IDC_CI},
																						 {CONTROL+SHIFT, 'I', IDC_CI},
																						 {META, 'I', IDC_MI},
																						 {META+SHIFT, 'I', IDC_MI},
																						 {'\0'}}},
	{"toggle-input-method",			IDS_IME,		CCommands::ToggleInputMethod,		{{CONTROL+CONTROLX, 'J', IDC_CXCJ},
																						 {CONTROL+SHIFT+CONTROLX, 'J', IDC_CXCJ},
																						 {CONTROL, 'O', IDC_CO2},
																						 {CONTROL+SHIFT, 'O', IDC_CO2},
																						 {CONTROL, 0xDC, IDC_CBACKSLASH},
																						 {CONTROL, 0xE2, IDC_CBACKSLASH_106},
																						 {'\0'}}},
	{"transpose-chars",				IDS_KILL,		CCommands::TransposeChars,			{{CONTROL, 'T', IDC_CT},
																						 {CONTROL+SHIFT, 'T', IDC_CT},
																						 {'\0'}}},
	{"undo",						IDS_RECOVERY,	CCommands::Undo,					{{CONTROLX, 'U', IDC_CXU},
																						 {CONTROL+SHIFT, 0xBD, IDC_C_},
																						 {CONTROL, 0xBF, IDC_CSLASH},
																						 {CONTROL+SHIFT, 0xE2, IDC_C_},
																						 {'\0'}}},
	{"universal-argument",			IDS_OTHER,		CCommands::UniversalArgument,		{{CONTROL, 'U', IDC_CU},
																						 {CONTROL+SHIFT, 'U', IDC_CU},
																						 {'\0'}}},
	{"write-file",					IDS_FILES,		CCommands::WriteFile,				{{CONTROL+CONTROLX, 'W', IDC_CXCW},
																						 {CONTROL+SHIFT+CONTROLX, 'W', IDC_CXCW},
																						 {'\0'}}},
	{"yank",						IDS_KILL,		CCommands::Yank,					{{CONTROL, 'Y', IDC_CY},
																						 {CONTROL+SHIFT, 'Y', IDC_CY},
																						 {'\0'}}},
	{"yank-pop",					IDS_KILL,		CCommands::YankPop,					{{META, 'Y', IDC_MY},
																						 {META+SHIFT, 'Y', IDC_MY},
																						 {'\0'}}},
	{"",							0,				NULL,								{'\0'}}
};

#endif // !defined(AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_)
