// xkeymacsdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "resource.h"
#include "Utils.h"
#include "Commands.h"
#include <afxdllx.h>
#include <math.h>
#include <Imm.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE XkeymacsdllDLL = { NULL, NULL };

static HINSTANCE g_hDllInst = NULL;

HINSTANCE GetThisHInst()
{
	return g_hDllInst;
}

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	g_hDllInst = hInstance;
	
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH) {
		TRACE0("XKEYMACSDLL.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(XkeymacsdllDLL, hInstance)) {
			return 0;
		}

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(XkeymacsdllDLL);
	} else if (dwReason == DLL_PROCESS_DETACH) {
		TRACE0("XKEYMACSDLL.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(XkeymacsdllDLL);
	}
	return 1;   // ok
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsDll Class
//////////////////////////////////////////////////////////////////////

#include "xkeymacsDll.h"
#pragma data_seg(".xkmcs")
	HHOOK	CXkeymacsDll::m_hHookKeyboard = NULL;
	HHOOK	CXkeymacsDll::m_hHookCallWnd = NULL;
	HHOOK	CXkeymacsDll::m_hHookGetMessage = NULL;
	int		CXkeymacsDll::m_nCommandID[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY] = {'\0'};
	char	CXkeymacsDll::m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH] = {'\0'};
	HWND	CXkeymacsDll::m_hPrevWnd = 0;
	BOOL	CXkeymacsDll::m_bRightControl	= FALSE;
	BOOL	CXkeymacsDll::m_bRightAlt		= FALSE;
	BOOL	CXkeymacsDll::m_bRightShift		= FALSE;
	BOOL	CXkeymacsDll::m_bImeComposition	= FALSE;
	BOOL	CXkeymacsDll::m_bHook			= TRUE;
	NOTIFYICONDATA CXkeymacsDll::m_stNtfyIcon[MAX_ICON] = {'\0'};
	HICON	CXkeymacsDll::m_hDisable[MAX_ICON] = {'\0'};
	HICON	CXkeymacsDll::m_hEnable[MAX_ICON] = {'\0'};
	BOOL	CXkeymacsDll::m_bIcon[MAX_ICON] = {'\0'};
	int		CXkeymacsDll::m_nKillRingMax[MAX_APP] = {'\0'};
	int		*CXkeymacsDll::m_pnKillRingMax = NULL;
	CStringList *CXkeymacsDll::m_pKillRing[MAX_APP] = {'\0'};
	int		CXkeymacsDll::m_nKillRing = 0;
	BOOL	CXkeymacsDll::m_bOriginal[MAX_COMMAND_TYPE][MAX_KEY] = {'\0'};
	int		CXkeymacsDll::m_nApplicationID = 0;
	int		CXkeymacsDll::m_nSettingStyle[MAX_APP] = {'\0'};
	BOOL	CXkeymacsDll::m_bIgnoreUndefinedMetaCtrl[MAX_APP] = {'\0'};
	BOOL	CXkeymacsDll::m_bIgnoreUndefinedC_x[MAX_APP] = {'\0'};
#pragma data_seg()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsDll::CXkeymacsDll()
{
	CUtils::InitCUtils();
}

CXkeymacsDll::~CXkeymacsDll()
{

}

int CXkeymacsDll::ModifyShell_NotifyIcon(icons icon, BOOL bNewStatus)
{
	if (m_stNtfyIcon[icon].hIcon == (bNewStatus ? m_hEnable[icon] : m_hDisable[icon])) {
		return TRUE;
	} else {
		m_stNtfyIcon[icon].hIcon = (bNewStatus ? m_hEnable[icon] : m_hDisable[icon]);
	}
	return DoShell_NotifyIcon(icon, NIM_MODIFY);
}

void CXkeymacsDll::SetNotifyIconData(icons icon, NOTIFYICONDATA stNtfyIcon, HICON hIconEnable, HICON hIconDisable, BOOL bEnable)
{
	m_hEnable[icon] = hIconEnable;
	m_hDisable[icon] = hIconDisable;
	m_bIcon[icon] = bEnable;
	m_stNtfyIcon[icon] = stNtfyIcon;
	AddShell_NotifyIcon(icon);
}

void CXkeymacsDll::EnableShell_NotifyIcon(icons icon, BOOL bEnable)
{
	DeleteShell_NotifyIcon(icon);
	m_bIcon[icon] = bEnable;
	AddShell_NotifyIcon(icon);
}


BOOL CXkeymacsDll::DoShell_NotifyIcon(icons icon, DWORD dwMessage)
{
	if (m_bIcon[icon]) {
		return ::Shell_NotifyIcon(dwMessage, &m_stNtfyIcon[icon]);
	} else {
		return TRUE;
	}
}

int CXkeymacsDll::AddShell_NotifyIcon(icons icon)
{
	return DoShell_NotifyIcon(icon, NIM_ADD);
}

int CXkeymacsDll::DeleteShell_NotifyIcon(icons icon)
{
	return DoShell_NotifyIcon(icon, NIM_DELETE);
}

// set keyboard hook
BOOL CXkeymacsDll::SetKeyboardHook()
{
	m_hHookKeyboard = ::SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)KeyboardProc, GetThisHInst(), 0);
	if (!m_hHookKeyboard) {
		return FALSE;
	}

	m_hHookCallWnd = ::SetWindowsHookEx(WH_CALLWNDPROC, (HOOKPROC)CallWndProc, GetThisHInst(), 0);
//	if (!m_hHookCallWnd) {
//		return FALSE;
//	}

	m_hHookGetMessage = ::SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)GetMessageProc, GetThisHInst(), 0);

	AddShell_NotifyIcon(MAIN_ICON);

	return TRUE;
}

// release keyboard hook
BOOL CXkeymacsDll::ReleaseKeyboardHook()
{
	BOOL bKeyboard = TRUE;
	BOOL bCallWnd = TRUE;
	BOOL bGetMessage = TRUE;

	if (m_hHookKeyboard) {
		bKeyboard = ::UnhookWindowsHookEx(m_hHookKeyboard);
	}
	m_hHookKeyboard = NULL;

	if (m_hHookCallWnd) {
		bCallWnd = ::UnhookWindowsHookEx(m_hHookCallWnd);
	}
	m_hHookCallWnd = NULL;

	if (m_hHookGetMessage) {
		bGetMessage = ::UnhookWindowsHookEx(m_hHookGetMessage);
	}
	m_hHookGetMessage = NULL;

	DoShell_NotifyIcon(MAIN_ICON, NIM_DELETE);
	DoShell_NotifyIcon(CX_ICON, NIM_DELETE);
	DoShell_NotifyIcon(META_ICON, NIM_DELETE);
	DoShell_NotifyIcon(SHIFT_ICON, NIM_DELETE);
	DoShell_NotifyIcon(CTRL_ICON, NIM_DELETE);
	DoShell_NotifyIcon(ALT_ICON, NIM_DELETE);

	return bKeyboard && bCallWnd && bGetMessage;
}

void CXkeymacsDll::SetKeyboardHookFlag(BOOL bFlag)
{
	m_bHook = bFlag;

	if (m_bHook) {
		m_stNtfyIcon[MAIN_ICON].hIcon = m_hEnable[MAIN_ICON];
	} else {
		m_stNtfyIcon[MAIN_ICON].hIcon = m_hDisable[MAIN_ICON];
	}
	DoShell_NotifyIcon(MAIN_ICON, NIM_MODIFY);
}

// if be keyboard hook, return TRUE
BOOL CXkeymacsDll::IsKeyboardHook()
{
//	if (m_hHookKeyboard) {
	if (m_bHook) {
		return TRUE;
	}

	return FALSE;
}

LRESULT CALLBACK CXkeymacsDll::CallWndProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if (0 <= nCode) {
		CWPSTRUCT &cwps = *(CWPSTRUCT *)lParam;
		switch (cwps.message) {
		case WM_IME_STARTCOMPOSITION:
			m_bImeComposition = TRUE;
			break;
		case WM_IME_ENDCOMPOSITION:
			m_bImeComposition = FALSE;
			break;
		}
	}
	return CallNextHookEx(m_hHookCallWnd, nCode, wParam, lParam);
}

LRESULT CALLBACK CXkeymacsDll::GetMessageProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	MSG &msg = (*(MSG *)lParam);

	switch (msg.message) {
	case WM_IME_STARTCOMPOSITION:
		m_bImeComposition = TRUE;
		break;
	case WM_IME_ENDCOMPOSITION:
		m_bImeComposition = FALSE;
		break;
	}
	return CallNextHookEx(m_hHookGetMessage, nCode, wParam, lParam);
}

// return true if the key is down
inline BOOL CXkeymacsDll::IsDown(BYTE bVk)
{
	return (GetKeyState(bVk) < 0);
}

// Do keybd_event
void CXkeymacsDll::DoKeybd_event(BYTE bVk, DWORD dwFlags)
{
	// Set KEYEVENTF_EXTENDEDKEY if needed
	switch (bVk) {
	case VK_CONTROL:
		if (m_bRightControl) {		// Right Ctrl
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_MENU:
		if (m_bRightAlt) {			// Right Alt
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_SHIFT:
		if (m_bRightShift) {		// Right Shift
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_PAUSE:
		if (IsDown(VK_CONTROL)) {	// Break
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_INSERT:
	case VK_DELETE:
	case VK_HOME:
	case VK_END:
	case VK_NEXT:
	case VK_PRIOR:
	case VK_UP:
	case VK_DOWN:
	case VK_RIGHT:
	case VK_LEFT:
	case VK_NUMLOCK:
	case VK_PRINT:
		dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	default:
		break;
	}

	keybd_event(bVk, (BYTE)MapVirtualKey(bVk, 0), dwFlags, 0);
}

// the key is being depressed
inline void CXkeymacsDll::DepressKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, 0);
}

// the key is being released
inline void CXkeymacsDll::ReleaseKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, KEYEVENTF_KEYUP);
}

// bVk down, bVk up
inline void CXkeymacsDll::Kdu(BYTE bVk, DWORD n)
{
	while (n--) {
		DepressKey(bVk);
		ReleaseKey(bVk);
	}
}

CSearchKey::CSearchKey()
{
	m_bFindWhat				= 'N';
	m_bDirectionForward		= 'D';
	m_bDirectionBackward	= 'U';
	m_bSearchOption			= 0;
}

CSearchKey::CSearchKey(CString *szDialogTitle)
{
	m_bFindWhat				= 'N';
	m_bDirectionForward		= 'D';
	m_bDirectionBackward	= 'U';
	m_bSearchOption			= 0;

	if (CUtils::IsWordpad() ||
		CUtils::IsLotus123()) {
		m_bDirectionForward = m_bDirectionBackward = 0;
	} else if (CUtils::IsLotusNotes()) {
		// Lotus Notes
		m_bFindWhat				= 'F';
		m_bDirectionForward		= 'D';
		m_bDirectionBackward	= 'B';
		m_bSearchOption			= 'O';
	} else if (CUtils::IsBecky()) {
		// Becky!
		m_bFindWhat			= 'F';
		if (!szDialogTitle->Compare("{")) {
			m_bDirectionForward		= 'O';
			m_bDirectionBackward	= 'B';
		} else {
			m_bDirectionForward		= 0;
			m_bDirectionBackward	= 0;
		}
	} else if (CUtils::IsSakuraEditor()) {
		m_bFindWhat				= 0;
		m_bDirectionForward		= 'D';
		m_bDirectionBackward	= 'U';
	} else if (CUtils::IsHidemaru()) {
		m_bFindWhat				= 'S';
		m_bDirectionForward		= 'N';
		m_bDirectionBackward	= 'P';
	} else if (CUtils::IsK2Editor()) {
		m_bFindWhat				= 0;
		m_bDirectionForward		= 'L';
		m_bDirectionBackward	= 'U';
	}

	if (CUtils::IsOutlook() &&
		!szDialogTitle->Compare("Find")) {
		// Outlook (English version)
		m_bDirectionForward = m_bDirectionBackward = 0;
	}
}

CSearch::CSearch()
{
	CUtils::GetFindDialogTitle(&m_szDialogTitle);

	m_pKey = new CSearchKey(&m_szDialogTitle);
}

// emulate emacs	// cf virtual-key code
LRESULT CALLBACK CXkeymacsDll::KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	ASSERT(0 <= wParam && wParam <= UCHAR_MAX);

	static BOOL bImeComposition	= FALSE;
	HWND		hCurrentWnd = GetFocus();
	static WPARAM wLastParam = 0;
	int nCommandType = NONE;
	BYTE nKey = (BYTE)wParam;

	if (nCode < 0 || nCode == HC_NOREMOVE) {
		goto DO_NOTHING;
	}

	if (wParam == VK_CONTROL ||
		wParam == VK_MENU ||
		wParam == VK_SHIFT) {
		goto DO_NOTHING;
	}

	if (lParam & 0x80000000) {
		goto DO_NOTHING;
	}

	if (!m_hPrevWnd || (m_hPrevWnd != hCurrentWnd) || (bImeComposition != m_bImeComposition)) {
		if (m_hPrevWnd != hCurrentWnd) {
			m_bImeComposition = FALSE;
		}

		CString szApplicationNameOrg(CUtils::GetApplicationName());
		CUtils::SetApplicationName(m_bImeComposition);

		if (stricmp(m_szSpecialApp[m_nApplicationID], CUtils::GetApplicationName())) {
			for (m_nApplicationID = 0; m_nApplicationID < MAX_APP; m_nApplicationID++) {
				if (!stricmp(m_szSpecialApp[m_nApplicationID], CUtils::GetApplicationName())) {
					break;
				}
			}
			if (m_nApplicationID == MAX_APP) {
				for (m_nApplicationID = 0; m_nApplicationID < MAX_APP; m_nApplicationID++) {
					if (!stricmp(m_szSpecialApp[m_nApplicationID], "Default")) {
						break;
					}
				}
				if (m_nApplicationID == MAX_APP) {
					m_nApplicationID = 0;
				}
			}
		}

		m_hPrevWnd		= hCurrentWnd;
		bImeComposition	= m_bImeComposition;
		ModifyShell_NotifyIcon(CX_ICON, FALSE);
		ModifyShell_NotifyIcon(META_ICON, FALSE);
		wLastParam		= 0;
		m_pKillRing[m_nApplicationID]	= new CStringList();
		m_pnKillRingMax	= &(m_nKillRingMax[m_nApplicationID]);

		CCommands::Reset();

		if (strcmp(CUtils::GetApplicationName(), szApplicationNameOrg)) {
			CCommands::SearchDirection(NA);
		}
	}

	if (m_nSettingStyle[m_nApplicationID] == SETTING_DISABLE) {
		goto DO_NOTHING;
	}

	// Do Nothing for Meadow, Mule for Win32, ... if those use default setting.
	{
		if (!stricmp(m_szSpecialApp[m_nApplicationID], "Default")) {
			if (CUtils::IsDefaultIgnoreApplication()) {
				goto DO_NOTHING;
			}
		}
	}

	// set command type
	{
		nCommandType = NONE;
		if (IsDown(VK_SHIFT)) {
			nCommandType += SHIFT;
		}
		if (IsDown(VK_CONTROL)) {
			nCommandType += CONTROL;
		}
		if (IsMeta()) {
			nCommandType += META;
		}
		if (CCommands::bC_x()) {
			nCommandType += CONTROLX;
		}

		if (nCommandType & CONTROLX) {
			if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == NULL) {
				if (m_bIgnoreUndefinedC_x[m_nApplicationID]) {
					CCommands::Reset(GOTO_HOOK);
					goto HOOK;
				}
				nCommandType -= CONTROLX;
			}
		}
		if (nCommandType & META) {
			if (!IsDown(VK_MENU) && Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == NULL) {
				if (m_bIgnoreUndefinedMetaCtrl[m_nApplicationID]) {
					CCommands::Reset(GOTO_HOOK);
					goto HOOK;
				}
				nCommandType -= META;
			}
		}
	}

	if (Original(nCommandType, nKey)) {
		Original(nCommandType, nKey, FALSE);
		goto DO_NOTHING;
	}

	if (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand == CCommands::EnableOrDisableXKeymacs) {
		SetKeyboardHookFlag(!m_bHook);
		goto HOOK;
	}
	if (!m_bHook) {
		goto DO_NOTHING;
	}

	if (CCommands::bC_u()) {
		if (nCommandType == NONE && '0' <= nKey && nKey <= '9') {
			CCommands::NumericArgument(nKey - '0');
			goto HOOK0_9;
		}
		if (nCommandType == NONE && nKey == 0xBD) {
			CCommands::NumericArgumentMinus();
			goto HOOK0_9;
		}
	}

	if (!Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand) {
		if (1 < CCommands::GetNumericArgument()) {
			Kdu(nKey, CCommands::GetNumericArgument());
			CCommands::ClearNumericArgument();
			goto HOOK;
		}
		goto DO_NOTHING;
	}

	m_bRightControl	= IsDown(VK_RCONTROL);
	m_bRightAlt		= IsDown(VK_RMENU);
	m_bRightShift	= IsDown(VK_RSHIFT);

	switch (Commands[m_nCommandID[m_nApplicationID][nCommandType][nKey]].fCommand()) {
	case GOTO_DO_NOTHING:
		goto DO_NOTHING;
	case GOTO_HOOK:
		goto HOOK;
	case GOTO_RECURSIVE:
		goto RECURSIVE;
	case GOTO_HOOKX:
		goto HOOKX;
	case GOTO_HOOK0_9:
		goto HOOK0_9;
	default:
		ASSERT(0);
		goto DO_NOTHING;
	}

DO_NOTHING:
	if ((wParam != VK_SHIFT) &&
		(wParam != VK_CONTROL) &&
		(wParam != VK_MENU)) {
		wLastParam = wParam;
	}
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsDown(VK_CONTROL));
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
	return ::CallNextHookEx(m_hHookKeyboard, nCode, wParam, lParam);

RECURSIVE:
	Kdu((BYTE)wParam);
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsDown(VK_CONTROL));
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
	return TRUE;

HOOK:
	wLastParam = wParam;
HOOK0_9:
HOOKX:
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsDown(VK_CONTROL));
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsData Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsData::CXkeymacsData()
{
	ClearAll();
}

CXkeymacsData::~CXkeymacsData()
{

}

// set application name
void CXkeymacsData::SetApplicationName(LPCTSTR lpszApplicationName)
{
	m_strApplicationName.Format(lpszApplicationName);
}

// return application name
CString CXkeymacsData::GetApplicationName()
{
	return m_strApplicationName;
}

// set hook or not
void CXkeymacsData::SetCommandID(int nCommandType, int nKey, int nEnable)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	m_nCommandID[nCommandType][nKey] = nEnable;
}

// return hook or not
int CXkeymacsData::GetCommandID(int nCommandType, int nKey)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	return m_nCommandID[nCommandType][nKey];
}

// clear all data
void CXkeymacsData::ClearAll()
{
	ZeroMemory(m_nCommandID, sizeof(m_nCommandID));
	m_strApplicationName.Empty();
}

// set application name
void CXkeymacsDll::SetApplicationName(int nApplicationID, CString szApplicationName)
{
	ZeroMemory(m_szSpecialApp[nApplicationID], sizeof(m_szSpecialApp[nApplicationID]));
	strncpy(m_szSpecialApp[nApplicationID], szApplicationName, sizeof(m_szSpecialApp[nApplicationID]));
}

// set m_nCommandID[nApplicationID][nCommandType][nKey] nEnable
void CXkeymacsDll::SetCommandID(int nApplicationID, int nCommandType, int nKey, int nEnable)
{
	m_nCommandID[nApplicationID][nCommandType][nKey] = nEnable;
}

void CXkeymacsDll::SetKillRingMax(int nApplicationID, int nKillRingMax)
{
	m_nKillRingMax[nApplicationID] = nKillRingMax;
}

// Clear data of nApplicationID
void CXkeymacsDll::Clear(int nApplicationID)
{
	if (0 <= nApplicationID && nApplicationID < MAX_APP) {
		ZeroMemory(m_szSpecialApp[nApplicationID], sizeof(m_szSpecialApp[nApplicationID]));
		ZeroMemory(m_nCommandID[nApplicationID], sizeof(m_nCommandID[nApplicationID]));
		m_nKillRingMax[nApplicationID] = 0;
		m_nSettingStyle[nApplicationID] = 0;
	} else {
		ASSERT(0);
	}
}

// Set m_hPrevWnd 0 for that KeyboardProc() updates data 
void CXkeymacsDll::UpdateData()
{
	m_hPrevWnd = 0;
}

void CXkeymacsData::SetApplicationTitle(LPCTSTR lpszApplicationTitle)
{
	m_strApplicationTitle.Format(lpszApplicationTitle);
}

CString CXkeymacsData::GetApplicationTitle()
{
	return m_strApplicationTitle;
}

void CXkeymacsData::SetKillRingMax(int nKillRingMax)
{
	m_nKillRingMax = nKillRingMax;
}

int CXkeymacsData::GetKillRingMax()
{
	return m_nKillRingMax;
}

BOOL CXkeymacsDll::IsMeta()
{
	switch (CUtils::GetPlatformId()) {
	case VER_PLATFORM_WIN32_NT:
		return (IsDown(VK_RMENU) && m_nCommandID[m_nApplicationID][NONE][VK_RMENU]) ||	// doubt
			   (IsDown(VK_LMENU) && m_nCommandID[m_nApplicationID][NONE][VK_LMENU]) ||	// doubt
			   CCommands::bM_();
		break;
	case VER_PLATFORM_WIN32_WINDOWS:
		return (IsDown(VK_MENU) && m_nCommandID[m_nApplicationID][NONE][VK_MENU]) ||	// doubt
			   CCommands::bM_();
		break;
	default:
		return FALSE;
		break;
	}
}

void CXkeymacsDll::AddKillRing()
{
	if (*m_pnKillRingMax == 0) {
		return;
	}

	if (m_pKillRing[m_nApplicationID] == NULL) {
		m_pKillRing[m_nApplicationID] = new CStringList();
	}

	CString szClipboardText;
	CUtils::GetClipboardText(&szClipboardText);
	m_pKillRing[m_nApplicationID]->AddHead(szClipboardText);
	CUtils::SetClipboardText(&szClipboardText);

	m_nKillRing = 0;

	if (*m_pnKillRingMax < m_pKillRing[m_nApplicationID]->GetCount()) {
		m_pKillRing[m_nApplicationID]->RemoveTail();
	}
}

void CXkeymacsDll::GetKillRing()
{
	if (*m_pnKillRingMax == 0) {
		return;
	}

	if ((m_pKillRing[m_nApplicationID] == NULL) || (m_pKillRing[m_nApplicationID]->IsEmpty())) {
		return;
	}

	m_nKillRing %= m_pKillRing[m_nApplicationID]->GetCount();
	CString sz = m_pKillRing[m_nApplicationID]->GetAt(m_pKillRing[m_nApplicationID]->FindIndex(m_nKillRing));
	CUtils::SetClipboardText(&sz);
}

void CXkeymacsDll::Original(int nCommandType, BYTE bVk, BOOL b)
{
	m_bOriginal[nCommandType][bVk] = b;
}

BOOL CXkeymacsDll::Original(int nCommandType, BYTE bVk)
{
	return m_bOriginal[nCommandType][bVk];
}

void CXkeymacsDll::IncreaseKillRingIndex(int n)
{
	m_nKillRing += n;
}

// move CCommands
CString CXkeymacsData::GetCommandName(int nCommandID)
{
	CString szCommandName(Commands[nCommandID].szCommandName);
	return szCommandName;
}

// move CCommands
int CXkeymacsData::GetDefaultCommandType(int nCommandID, int nIndex)
{
	return Commands[nCommandID].keybind[nIndex].nCommandType;
}

// move CCommands
int CXkeymacsData::GetDefaultCommandKey(int nCommandID, int nIndex)
{
	return Commands[nCommandID].keybind[nIndex].bVk;
}

// move CCommands
int CXkeymacsData::GetDefaultControlID(int nCommandID, int nIndex)
{
	return Commands[nCommandID].keybind[nIndex].nControlID;
}

// nobody use
// return root window of focused window
HWND CXkeymacsDll::GetFocusRoot()
{
	HWND hWnd, hRootWnd;
	for (hRootWnd = hWnd = GetFocus(); hWnd; hWnd = GetParent(hWnd)) {
		hRootWnd = hWnd;
	}
	return hRootWnd;
}

// nobody use
int CXkeymacsDll::GetMickey(int nDifferential, int nThreshold1, int nThreshold2, int nAcceleration, int nSpeed)
{
	nDifferential = nDifferential * 10 / nSpeed;

	switch (nAcceleration) {
	case 2:
		if (nThreshold2 < fabs(nDifferential / 4)) {
			nDifferential /= 4;
			break;
		}
		// Do NOT write break; here.
	case 1:
		if (nThreshold1 < fabs(nDifferential / 2)) {
			nDifferential /= 2;
		}
		break;
	case 0:
		break;
	default:
		ASSERT(0);
		break;
	}

	return nDifferential;
}


int CXkeymacsData::GetSettingStyle()
{
	return m_nSettingStyle;
}

void CXkeymacsData::SetSettingStyle(int nSettingStyle)
{
	m_nSettingStyle = nSettingStyle;
}

void CXkeymacsDll::SetSettingStyle(int nApplicationID, int nSettingStyle)
{
	m_nSettingStyle[nApplicationID] = nSettingStyle;
}

int CXkeymacsData::GetCategoryID(int nCommandID)
{
	return Commands[nCommandID].nCategoryID;
}

void CXkeymacsData::SetIgnoreUndefinedMetaCtrl(BOOL bIgnoreUndefinedMetaCtrl)
{
	m_bIgnoreUndefinedMetaCtrl = bIgnoreUndefinedMetaCtrl;
}

BOOL CXkeymacsData::GetIgnoreUndefinedMetaCtrl()
{
	return m_bIgnoreUndefinedMetaCtrl;
}

void CXkeymacsDll::SetIgnoreUndefinedMetaCtrl(int nApplicationID, BOOL bIgnoreUndefinedMetaCtrl)
{
	m_bIgnoreUndefinedMetaCtrl[nApplicationID] = bIgnoreUndefinedMetaCtrl;
}

void CXkeymacsData::SetIgnoreUndefinedC_x(BOOL bIgnoreUndefinedC_x)
{
	m_bIgnoreUndefinedC_x = bIgnoreUndefinedC_x;
}

BOOL CXkeymacsData::GetIgnoreUndefinedC_x()
{
	return m_bIgnoreUndefinedC_x;
}

void CXkeymacsDll::SetIgnoreUndefinedC_x(int nApplicationID, BOOL bIgnoreUndefinedC_x)
{
	m_bIgnoreUndefinedC_x[nApplicationID] = bIgnoreUndefinedC_x;
}
